# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

_d_sigs_count=5

  init_args
  arg_value d,"baud divisor"
  call strtoul_
  mov %al,baud_divisor
  ret
.data
baud_divisor: .byte 1
  arg_value o,"output file"
  lea ofn,%di
   call strcpy_
   ret
.data 
ofn: .space 0x80
  init_args_term
  port2uart port
  mov %ax,port_uart

  xcreate_file $ofn,$0
  mov %ax,handle

   serial_config port_uart,baud_divisor
   call wait_sig
  mov %ax,blocksize
  fdprint  handle,"got blocksize of "
  fdhex handle,16,blocksize,$'\n'
   serial_putc $'b',port_uart
  call get_fn
  call get_fsz
   serial_putc $'f',port_uart
  fdprint handle,"got fn="
    fdprint handle,,fn
    fdprint handle,"\ngot fsz="
   fdhex handle,32,fsz,$'\n'
exit_prog: serial_config port_uart,$12
  mov handle,%bx
  dos_close_file
mov exit_rc,%al
  dos_exit
wait_sig:
  zeroreg %cl
1:  serial_getch port_uart,$1000
  jc 0f
  if %al,ne,$1,0f
  jmp 2f
0:  push %ax
bios_check_keystroke
   jz 0f
  movb $1,exit_rc
  jmp exit_prog
0:  dos_playnote_ms $440,$500
   pop %ax
  if %ax,e,$_d_serial_time_out,1b
  zeroreg %cl
  jmp 1b
2: inc %cl
  if %cl,be,$_d_sigs_count,1b
  serial_putc $'s',port_uart
   serial_getch port_uart,$1000
  mov %al,%ah
   serial_getch port_uart,$1000
   xchg %al,%ah
  ret
get_fn:
  lea fn,%di
0:   bios_check_keystroke
  je 1f
   movb $1,exit_rc
   jmp exit_prog
1:  serial_getch port_uart,$1000
   jc 0b
   stosb
  if %al,e,$'\n',1f
    jmp 0b
1:  movb $0,(%di)
  ret
get_fsz:
  lea fsz,%di
  mov $4,%cx
0:   bios_check_keystroke
  je 1f
   movb $1,exit_rc
   jmp exit_prog
1:  serial_getch port_uart,$1000
   jc 0b
   stosb
    loop 0b
  ret
.data
port: .word 0
exit_rc: .byte 0
.bss
port_uart: .word 0
blocksize: .word 0
handle: .word 0
fn: .space 0x80
fsz: .long 0
