# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

   port2uart port
  mov %ax,uart
  serial_config uart,$1
  xcreate_file $fn,$0
   mov %ax,handle
0:  bios_check_keystroke
  jne exit_prog
   serial_getch uart,$1000
  if %ax,ne,$_d_serial_time_out,1f
   dos_playnote_ms $440,$100
  jmp 0b
1: if_nz got_first,2f,b
    mov %al,last_char
  movb $1,got_first
   jmp 0b
2:  mov last_char,%ah
   inc %ah
   if %al,ne,%ah,2f
  mov %al,last_char
  mov %al,%bl
  jmp 0b
2:  movb $0,got_first
   mov %ax,%bx
   do_fd handle,"failed al=",hex,8,%ebx
  mov %bh,%bl
  do_fd handle,"last char=",hex,8,%ebx,$'\n'
  dos_playnote_ms $110,$500
  jmp 0b
exit_prog:  mov handle,%bx
  dos_close_file
 terminate 00
.data
port: .word 0
uart: .word 0
got_first: .byte 0
last_char: .byte 0
handle: .word 0
fn: .asciz "comrcv.dat"
