# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

 init_args
   arg_value o,"output file"
  lea ofn,%di
  call strcpy_
  ret
.data
ofn: .space 0x80
   arg_value p,"port"
  call stowd
  dec %ax
  mov %ax,port
  ret
.data
port: .word 0
   arg_item r,running_status,"get running status"
arg_value d,"divisor"
   call strtoul_
  mov %ax,divisor
   ret
.data
divisor:  .word 0
  init_args_term

0:
  port2uart port
  mov %ax,uart
   if_z divisor,0f,w
     serial_config uart,divisor
0:

  xcreate_file $ofn,$0
    mov %ax,handle

    mov uart,%dx
  add $_d_lcr,%dx
  mov %dx,%cx
    in (%dx),%al
  mov %al,%bl
  or $0x80,%al
   out %al,(%dx) # switch dlab on
      sub $_d_lcr,%dx
    in (%dx),%ax # get baud rate divisor
  mov %al,%ah
   mov %bl,%al
  and $0x7f,%al
  mov %cx,%dx # back to lcr
  out %al,(%dx) # switch off dlab
  mov %ah,%al
   fdprint handle,"baud rate divisor="
  fdhex handle,8,%eax,$'\n'
  mov uart,%dx
  add $_d_ier,%dx
   in (%dx),%al
  fdprint handle,"ier="
  fdhex handle,8,%eax,$'\n'
  mov uart,%dx
  add $_d_iir,%dx
   in (%dx),%al
  fdprint handle,"iir="
  fdhex handle,8,%eax,$'\n'


  if_z  running_status,999f,b

send_loop_start:    bios_check_keystroke
  jnz 999f
   serial_status uart
  if_unset $1,%ah,2f
  call got_char
2:
  cmp %ax,old_status
   mov %ax,old_status
  je send_loop_start
  push %ax
  call print_status
  jmp  send_loop_start
999:  mov handle,%bx
  dos_close_file
terminate 00
print_status:
  _enter
  pusha
  fdhex handle,16,4(%bp),$'\n'
  popa
  leave
ret $2
got_char:
   pusha
  mov uart,%dx
   in (%dx),%al
  do_fd handle,"ch=",hex,8,%eax,$'\n'
  popa
   ret

.data
output_line: .ascii "ax="
output_ax: .asciz "1234\n"
.bss
handle: .word 0
uart: .word 0
old_status: .word 0
