# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

 port2uart port
   mov %ax,uart
   serial_config uart,$12
     xcreate_file $fn,$0
  mov %ax,handle
0:  call process_bytes
  jmp 0b
exit_prog:
  mov handle,%bx
  dos_close_file
    terminate 00

lstruct
lsym buf .word 0
lstruct_end
process_bytes:
  enter $lstruct_sz,$0
  mov  uart,%dx
  add $_d_msr,%dx
  in (%dx),%al
  mov uart,%dx
  add $_d_mcr,%dx
   mov $3,%al
  out %al,(%dx)
  bios_check_keystroke
  jnz exit_prog
   serial_getch uart,$1000
  if %ax,ne,$_d_serial_time_out,0f
    dos_playnote_ms $440,$100
   jmp 999f
0:     mov $1,%cx
  lea buf(%bp),%dx
  mov %ax,buf(%bp)
     mov handle,%bx
   dos_write_handle
999:  leave
 ret
.data
fn: .asciz "comtest.dat"
port:  .word 0
.bss
uart: .word 0
handle: .word 0
