# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "dt_tsr.h"
.include "dt_tsr_map.h"

.section sect
  int21_call
.previous

   init_args
  arg_item q,quiet,"quiet"
  arg_item x,examine,"examine ,tsr ie. where the hellis it"
  arg_item s,switch_tsr_off,"stop the tsr sending"
  arg_item S,switch_tsr_on,"switch tsr on"
  init_args_term
  vector dos_getvector  
  if%es:sig(%bx),ne,$tsr_sig,not_loaded,w
    if_z switch_tsr_off,0f,b
   movb $1,%es:shut_up
   terminate 00
0:
    if_z switch_tsr_on,0f,b
   movb $0,%es:shut_up
   terminate 00
0:
  if_nz quiet,0f,b
  info_print "Vector is set to ->",%es,%bx
  if_z examine,0f,b
   terminate 00
0: if_nz quiet,0f
  puts "unloading tsr"
0: push %bx
    mov %es,%bx
   dos_set_psp
   mov %es:tsr_handle,%bx
  dos_close_file
  jnc 0f
   puts "failed closing tsr log file"
0:  mov %cs,%bx
  dos_set_psp
   pop %bx
  push %ds
  movseg %es:jaddr+2(%bx),%ds
  mov %es:jaddr(%bx),%dx
  vector dos_setvector
  movseg %es:jaddr15+2(%bx),%ds
  mov %es:jaddr15(%bx),%dx
  dos_setvector 15
  dos_free
  pop %ds
  info_print "should be unloaded set vector to ->",%ds,%dx
  puts "Resetting the doubletalk"
  call dt_init
    mov $0x18,%ah
    call dt_putc
  terminate 00
not_loaded: 
  puts "tsr not loaded"
terminate 01
