# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

  mov drive,%dl
ibm_ext_check
  exit_if_cf $1,"drive extensions not available"
  if %bx,e,$0xaa55,0f
   exit_msg $1,"invalid bx this shoudnt happen"
0: if %ah,a,$0x1,0f
   fdprint $1,"1.x "
   jmp 2f
0: if %ah,a,$0x20,0f
   fdprint $1,"2.0 / EDD 1.0 "
   jmp 2f
0: if %ah,a,$0x21,0f
   fdprint $1,"2.1 / EDD 1.1 "
   jmp 2f
0: if %ah,a,$0x30,0f
   fdprint $1,"EDD 3.0 "
   jmp 2f
0: mov %ah,%al
    do_fd $1,"got ver of unknown",hex,8,%eax
2: fdputc $'\n',$1
  mov drive,%dl
  lea parm_buf,%si
   ext_drive_parms
   exit_if_cf $1,"failed getting drive parms"
exit_prog:
  do_fd $1,"information flags=",hex,16,2(%si),$'\n'
  do_fd $1,"physical cylinders=",hex,32,4(%si),$'\n'
  do_fd $1,"physical heads=",hex,32,8(%si),$'\n'
  do_fd $1,"physical sectors=",hex,32,0xc(%si),$'\n'
  do_fd $1,"total sectors=",hex,32,0x10(%si),$'\n'
  do_fd $1,"bytes per sector=",hex,16,0x18(%si),$'\n'
  do_fd $1,"edd config parms=",hex,32,0x1a(%si),$'\n'
  do_fd $1,"edd sig=",hex,32,0x1e(%si),$'\n'
  do_fd $1,"edd len=",hex,32,0x20(%si),$'\n'
  push 0x24(%si)
   push $1
    call fdprint
  push 0x28(%si)
   push $1
    call fdprint
  push 0x30(%si)
   push $1
    call fdprint
  push 0x38(%si)
   push $1
    call fdprint
   terminate 00
.data
drive: .byte 0x80
parm_buf: .word 0x42
