# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

  call findpnp
  exit_if_nz $1,"cant find pnp"
   mov %ax,%bp
   shr $16,%eax
   mov %ax,%fs
       do_fd $1,"real mode seg:offs=",hex,16,%fs:0xf(%bp)
   do_fd $1,":",hex,16,%fs:0xd(%bp),$'\n'
   mov %fs:0xd(%bp),%eax
  mov %eax,entry_point
  pnp_get_system_nodes entry_point,$num_nodes,$node_sz
  if_rz %ax,0f
   exit_msg $1,"cant get system nodes"
0:

  do_fd $1,"num nodes=",hex,8,num_nodes,$'\n'
  do_fd $1,"size of largest node=",hex,16,node_sz,$'\n'
  fdprint $1,"checking for bios boot spec\n"
  bbs_install_check entry_point,$bbs_ver
  if_z %ax,0f
   exit_msg $1,"bios boot spec not supported"
0:
     do_fd $1,"bbs ver=",hex,16,bbs_ver,$'\n'
  bbs_get_ipl_dev_count entry_point,$num_ipl_devs,$max_ipl_devs,$ipl_entry_sz
    if_rz %ax,0f
   exit_msg $1,"non zero in ax"
0:   do_fd $1,"num ipl devs="hex,16,num_ipl_devs,$'\n'
   do_fd $1,"max ipl devs="hex,16,max_ipl_devs,$'\n'
   do_fd $1,"ipl entry sz=="hex,16,ipl_entry_sz,$'\n'
    xpushregs %ds,$cur_boot_idx,$0x65
   pnpcall entry_point
  add $6,%sp
   if_rz %ax,0f
   exit_msg $1,"failed"
0:  do_fd $1,"boot first=",hex,16,cur_boot_idx,$'\n'
  terminate 00    
    
.data
entry_point: .long 0
num_nodes: .byte 0
node_sz: .word 0
bbs_ver: .word 0
num_ipl_devs: .word  -1
max_ipl_devs: .word -1
ipl_entry_sz: .word -1
cur_boot_idx: .word 0
