# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

numsecs=1
sector=1
cyl=0
head=0
  call pinit
  if_z %ax,parmerror
  call extract_options
  mov argv,%si
  call stowd
   jc parmerror
  mov %al,drive
   jmp eocmd

parmerror:
  movseg %cs,%ds
   puts "Need drive to get parms for"
  terminate 01
eocmd:
  mov drive,%dl
  movseg $0,%es
  xor %di,%di
  get_drive_parameters
  jnc 100f
  print "Error getting drive parms status="
  mov %ax,%dx  
call hexoutword   
   dos_newline
  terminate 01
100: 
 mov %ch,max_cyls
  mov %cl,%al
  and $0x3f,%al
  mov %al,maxsectors
  shr $6,%cl
  mov %cl,max_cyls+1
  inc %dh
  mov %dh,maxheads
 mov %dl,maxdrives
  if_z print_sparse,0f,b
  call do_print_sparse
  terminate 00
0:
print  "drive parms for drive:"
  mov drive,%dl
  call hexoutchar
  dos_writedl_con $'\n'
  print "drive type="
  mov %bl,%dl  
call hexoutchar
  dos_writedl_con $'\n'
  print "Max cylinders="  
mov max_cyls,%dx
 call hexoutword 
  dos_writedl_con $'\n'
  print "Max sectors="
  mov maxsectors,%dl
  call hexoutchar
  dos_writedl_con $'\n'
  print "maximum heads="
  mov maxheads,%dl
  call hexoutchar  
 dos_writedl_con   $'\n'
print "Mximum drives="
  mov maxdrives,%dl
  call hexoutchar
  dos_writedl_con $'\n'
  terminate 00
extract_options:
  mov argc,%cx
   lea argv,%bx
0:
  mov (%bx),%si
  lodsb
  if %al,ne,$'-',1f
   lodsb
   if %al,e,$'s',2f
    exit_msg $1,"bad arg either drive number or s for sparse output"
2:
   incb print_sparse
  mov %bx,%si
  call dec_arg
   jmp 2f
1:
  add $sizeof_int,%bx
2:
   loop 0b
  ret
do_print_sparse:
  lea chex_hdr,%si
  call dos_print
  mov drive,%dl
  call hexoutchar
  dos_writedl_con $' '
  lea chex_hdr,%si
  call dos_print
  mov maxheads,%dl
  call hexoutchar
  dos_writedl_con $' '
  lea chex_hdr,%si
  call dos_print
  mov maxsectors,%dl
  call hexoutchar
  dos_writedl_con $' '
  lea chex_hdr,%si
  call dos_print
  mov max_cyls,%dx
  call hexoutword
   dos_newline
  ret
.data
drive: .byte 0
print_sparse: .byte 0
chex_hdr: .asciz "0x"
.bss
max_cyls: .word 0
maxsectors: .byte 0
maxheads: .byte 0
maxdrives: .byte 0
