# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"
# put as boot sector on floppy and overwrites itself with the bios + ebda
_d_start_seg=0xc000
_d_len=0x4000

  cli
  _set_segs %cs
   sti
  lea _start,%sp
 mov %dl,_drive
  pcicfg_read_byte $0,$0x59
    and $0xf,%al
  or $0x20,%al
  pcicfg_write_byte $0,$0x59,%ax
.if 0
  mov $6,%cx
  cld
 mov $0x5a,%bx
0:  pcicfg_read_byte $0,%bx
  mov $0x22,%ax
  pcicfg_write_byte $0,%bx,%ax
  inc %bx
  loop 0b
.endif
   
0:  push _wrk_seg
  push _len
  push _start_trk
  push _start_seg
 push _drive
  call write_chunk
 if %ax,ae,_len,exit_prog
 sub %ax,_len
  shl $5,%ax # convert tracks into paras
  add %ax,_start_seg
  incw _start_trk
 jmp 0b

exit_prog: 
playnote_ms  $440,$2000
 reboot


.struct 2*sizeof_int
drive: .word 0
start_seg: int_t 0
start_trk: int_t 0
num_secs: int_t 0
wrk_seg: int_t 0
estruct
write_chunk: _enter
  pusha
   xpushregs %ds,%es

  mov wrk_seg(_bp),%es
  mov num_secs(_bp),%cx
  if %cx,b,$18,0f
 mov $18,%cx
0: mov %cx, num_secs(_bp)
 shl $8,%cx
  zeroreg %di
  mov %di,%si
  push %ds
  mov start_seg(_bp),%ds
  cld
  rep movsw
 pop %ds

  mov $3,%cx
1: pusha
  mov _start_trk(_bp),%ax
  zeroreg %dx
  mov $2,%cx
  mov start_trk(_bp),%ax
  div %cx
  mov %dl,%dh
  mov %ax,%cx
  shl $6,%ch
  xchg %cl,%ch
  or $1,%cl
  mov drive(_bp),%dl
  zeroreg %bx
  mov wrk_seg(_bp),%es
 mov num_secs(_bp),%al
  write_sector
 mov  %ax,-2(_bp)
  popa
  jnc 0f
    loop 1b  
0:

  mov -2(_bp),%ax
 mov %ax,pushax_ax(_bp)
  xpopregs %es,%ds
   popa
 leave
  ret $ret_sz
_start_seg: .word _d_start_seg
_start_trk: .word 0
_wrk_seg: .word 0x6000
_len: .word _d_len/512
_drive: .byte 0
