# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
hack_30c0:movw   $0x0,0x5dd5
  if_nz 0x7728,0f,b
  call l30c0
  jmp 999f
0:   call ehci_30c0
999:   ret

ehci_30c0:movw   $0x0,0x5dd5
  movl $0x0,0x5dd7
  movw   $0x0,0x7453
  movb   $0x0,0x68ca
  movb   $0x2d,0x5dbe
  mov    0x6b44,%bl
  mov    %bl,0x5dbf
  mov    0x6b45,%bl
  mov    %bl,0x5dc0
  mov    0x6b54,%bx
  mov    %bx,0x5dc5
  mov    0x6b52,%bx
  mov    %bx,0x5dc7
 mov    $0x5d5d,%bx
  mov    %bx,0x5dcb
 push   %di
  movzbw 0x6b44,%di
  shl    $0x2,%di
  movb   $0x0,0x66cc(%di)
  pop    %di

 movb   $0x0,0x7908
  ehci16_simple_urb regs_base,0x53c5,0x53c3,0x5dc7,0x772b,0x5dbe,0x5dbf,0x5dc0
 jnc 0f
 movb  $0x1,0x7908
0:
  call   l1aeb
  dump_qtd 0x53c3

  call   l45d4
  cmpb   $0x0,0x6b47
  jne    l3170
  push   %di
  xor    %ax,%ax
  mov    0x6b44,%al
  mov    %ax,%di
  shl    $0x2,%di
  xor    %ax,%ax
  mov    $0x0,%al
  add    %ax,%di
  movb   $0x1,0x66cc(%di)
  pop    %di
h3170:mov    0x6b4c,%bx
  mov    %bx,0x5dc5
  mov    0x6b4a,%bx
  mov    %bx,0x5dc7
  cmpw   $0x0,0x5dc7
  jne    l319b
  cmpw   $0x0,0x5dc5
  jne    l319b
  movw   $0x8,0x5dd7
  jmp    l3209
h319b:call   zeromem_5557_2927
  movb   $0x1,0x5db0
  movb   $0x1,0x5db1
  call   l3463
  cmpb   $0x50,0x6b47
  je     l31bf
  cmpb   $0x0,0x6b47
  jne    l3209
h31bf:cmpw   $0x0,0x6b4e
  je     l3209
  mov    $0x5957,%ax
  mov    %ax,0x6b4a
  push   %ds
  popw   0x6b4c
  movw   $0x0,0x6b50
  movw   $0x0,0x6b4e
  movb   $0x1,0x5db0
  cmpb   $0x0,0x6b47
  jne    l3206
  push   %di
  xor    %ax,%ax
  mov    0x6b44,%al
  mov    %ax,%di
  shl    $0x2,%di
  xor    %ax,%ax
  mov    $0x0,%al
  add    %ax,%di
  movb   $0x1,0x66cc(%di)
  pop    %di
h3206:
call   l320a
h3209:
  puts "that is foks"
 ret    
do_setup_urb:
  mov %cs,%ax
  mov %ax,%ds
  mov %ax,%es
  pci16_find_class $_d_pci_ehci_usb_class
   pci16_read_dword %ax,$0x10
  mov %eax,%edx
  mov %edx,regs_base
  extmem_read_dword %edx,$_d_ehci_hscparams
   movzbw %al,%ax
  and $0xf,%al
  mov %ax,num_ports

  extmem_read_dword %edx,$0
   movzbl %al,%eax
   add %edx,%eax
    mov %eax,regs
   puts "\nsetup urb"
  extmem_read_dword regs,$_d_ehci_configflag
   or $1,%al
   extmem_write_dword regs,$_d_ehci_configflag,%eax

   mov $_d_ehci_portsc1,%bx
   mov num_ports,%cx
0:   extmem_read_dword regs,%bx
   or $_d_ehci_port_power|_d_ehci_port_pe,%ax
   extmem_write_dword regs,%bx,%eax
  add $4,%bx
   loop 0b

   extmem_read_dword regs,$_d_usbcmd
  or $_d_ehci_cmd_run,%al
  extmem_write_dword regs,$_d_ehci_usbcmd,%eax

  ehci_reset_port regs,$1

  f_memset $td_space,$0,$td_space_sz
  f_memset $buf_pg0,$0,$buf_pg0_sz
  f_memcpy $buf_pg0,$setup_urb,$setup_urb_sz

  lea td_space,%eax
    mov %cs,%edx
   shl $4,%edx
  add %edx,%eax
     align32_to %eax,$0x20
    extmem_write_dword regs,$_d_ehci_asynclistaddr,%eax
  sub %edx,%eax
   mov %ax,qh_p
  add $0x100,%ax
  mov %ax,qtd_p
  ehci_init_qh qh_p,$2,$0,$0,qtd_p
     make_linear %ds,$buf_pg0
  ehci_init_qtd qtd_p,$setup_urb_sz,$0x2d
  ehci_transaction regs
  dump_qtd qtd_p
  terminate 00
.include "dump_qtd.s"
setup_urb: .byte 0x80,0x06,0x00,0x01,0x00,0x00,0x08,0x00
setup_urb_sz=.-setup_urb
.bss
num_ports: .word 0
regs_base: .long 0
td_space: .space 0x200
td_space_sz=.-td_space
qh_p: .word 0
qtd_p: .word 0
buf_pg0: .space 4096
buf_pg0_sz=.-buf_pg0
regs: .long 0
.text
