#
#  asmlib, assembler library
#  Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 1, or (at your option)
#  any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#/
.ifndef __ved_h
__ved_h=1

.include "maclib.h"

input_line_len=80
file_buffer_size=512
# have found this by experimtaion. you can give a buffer size of
# 0xffff whic it seems to accepok but then it just blows up
# which is abou what youd expect of microsfts standards
# this seems safe enough though. if there is a limit  i haven't seen it written down
#anywhere soi'm going with this
max_buffer_size=0x7fff

goto_view_mode=0x4

.macro m_xlate_char char,str
   cmp $\char,%al
  jne 100f
   serial_print_nw "\str"
  jmp 999f
100:
.endm

.macro end_of_file goto=0
  cmp $0x75,%al 
.if \goto!=0
 jne \goto
.else
  jne l\@
.endif
   cmpw $0,ved_buf_len
   je l1\@
  call end_of_file
l1\@:
l\@:
.endm

.macro top_of_file goto=0
  cmp $0x77,%al 
.if \goto!=0
 jne \goto
.else
  jne l\@
.endif
   cmpw $0,ved_buf_len
   je l1\@
  lea edit_buffer+1,%di    
  movw $1,ved_col
   movw $1,ved_row
l1\@:
l\@:
.endm

.macro goto_line_end goto=0
  cmp $0x4f,%al 
.if \goto!=0
 jne \goto
.else
  jne l\@
.endif
   call goto_line_end
l\@:
.endm

.macro home_cursor goto=0
  cmp $0x47,%al # home
.if \goto!=0
 jne \goto
.else
  jne l\@
.endif
   call home_cursor
l\@:
.endm

.macro dbg_print str
.ifdef dbg
   puts "\str"
.endif
.endm

.macro serial_print_nw str
   lea 0f,%si 
  call   write_string
.data
0: .asciz "\\str"
.text
.endm
.macro bios_int14_puts str
  lea l\@,%si
  call write_string
.data
l\@: .asciz "\str"

.struct -16
s_pusha entry_
.text    
.endm

.macro ved_buf_t p,b=0,r=0,c=0,l=0,g=l
concat_lbl\g \p,struct
concat_lbl\g \p,buf_p int_t  \b
concat_lbl\g \p,row int_t \r
concat_lbl\g \p,col int_t \c
concat_lbl\g \p,buf_len,int_t \l
concat_lbl\g \p,cpos int_t 0
.endm

.ifdef xlate_kbd
.macro xlate_keys
  push _ax
   call win2dos_xlate
.endm
.else
.macro xlate_keys
.endm
.endif
.struct 0
ved_buf_t ved_buf_
.text
.endif
