# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

.macro int_hdlr_t p
concat_lbl \p,int_hdlr:
s_pushax_segs_t \p
s_pushal_t \p
concat_lbl \p,eip: int_t 0
concat_lbl \p,cs: int_t 0
concat_lbl \p,f: int_t 0
.endm

mkstruct int_hdlr
.text

gsym code32_start
  flip_cs $prot32_cs
   set_segs $prot32_ds
  movzwl %sp,%esp
  serial_puts uart,"the new stuff"
  set_intr_gate $3,$idt,%cs,$int3_hdlr
  set_intr_gate $0xff,$idt,%cs,$std_int_hdlr
  int $0x3
  int $0xff

   playnote_ms32 $440,$1000
   playnote_ms32 $55,$1000
   playnote_ms32 $440,$1000
  serial_puts32 uart,"ok thisis prot 32 ver 001"
# ok thats it now try and get back to real
  set_segs $prot16_ds
   flip_cs $prot16_cs,$prot16_start
set_dummy_idt:
  pusha
  cld
  mov $0x3,%ecx
  mov %esp,%esi
0:
  push $dummy_hdlr
   pushw $prot32_cs
  sub $6,%esp
  sidt (%esp)
  mov %cx,%ax
  dec %ax
  mov %ax,(%esp)
  call set_intr_gate
#  loop 0b
  popa
  ret 
gsym dummy_hdlr
  serial_puts32 uart,"ok here int 3 works ok\n"
  pushl $10*1000
   call usleep32
 iret

int3_hdlr:
  pusha
  serial_puts uart,"ok the 32 bit setup works"
  popa
  iret

std_int_hdlr:
  pusha
  xpushregs %ds,%es,%fs,%gs
  mov int_hdlr_eip(%esp),%eax
  mov int_hdlr_cs(%esp),%gs
  movzbl %gs:-1(%eax),%eax
 serial_puts uart,"this is the std hdlr"
  xpopregs %gs,%fs,%es,%ds
   popa
   iret
