# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"
# takes two args load image and optional addr
# loads the 32 bit image at addr or 0x100000 if not given 
# then jmps to that addr
# on exit segs are  flat 4gb ring 0
# stack is 4 bytes below max mem

   call  pinit
  if_rz %ax,1f
  mov argv,%si
    lea fn,%di
  call strcpy_
   if  argc,b,$2,1f
   mov argv+sizeof_int,%si
  call strtoul_
    mov %eax,load_addr
1:
   call cfg_ext_mem
  sub $4,%eax
  mov %eax,stack_end
   getfsize $fn
  mov %eax,fsz
    xopen_file $fn,$o_rdonly
  mov %ax,%bx
  ext_read %bx,load_addr,fsz
   exit_if_cf $1,"read failed"
   dos_close_file 
  mov %cs,%eax
  shl $4,%eax
  or %eax,gdt+real_cs+2
  or %eax,gdt+real_ds+2
 or %eax,gdt+load_cs+2
  or %eax,gdt+load_ds+2
    add $gdt,%eax
  mov %eax,gdtr+2
  call enable_a20
  cli
   lgdt gdtr
  lidt idtr
  mov %cr0,%eax
  or $1,%al
  mov %eax,%cr0
.code32
  flip_cs $load_cs
  set_segs $load_ds
  mov stack_end,%esp
  set_segs $boot_ds
   xpushregs $1000,$440
  call playnote_ms32
   .byte 0xea
load_addr: .long 0x100000,boot_cs

.data
fn: .asciz "vmlinux.bin"
.=fn+128
desc_start gdt
  .space 8
desc_entry boot_cs,0xffff,0,0x9a00,0xcf
desc_entry boot_ds,0xffff,0,0x9200,0xcf
desc_entry load_cs,0xffff,0,0x9a00,0xcf
desc_entry load_ds,0xffff,0,0x9200,0xcf
desc_entry real_cs,0xffff,0,0x9a00,0
desc_entry real_ds,0xffff,0,0x9200,0
gdtl=.-gdt
gdtr: .word gdtl-1,0,0
idtr: .space 6
.bss
stack_end: .long 0
fsz: .long 0
