# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

  call pinit
  if_z %ax,0f
    call parse_args
0:  call get_dta
  mov %eax,dta
  pushw $0
   pushw $ofn
    call xcreate_file
  mov %ax,handle
mov argc,%cx
  lea argv,%bx
  if_nz %cx,0f
   lea tmpl,%dx
  call do_dir
  jmp 999f
0: mov (%bx),%dx
  call do_dir
  add $sizeof_int,%bx
  loop 0b
  mov handle,%bx
  dos_close_file
999:  terminate 00
do_dir:
  xpushregs %bx,%cx
  mov $_d_fa_direc|_d_fa_rdonly|_d_fa_arch|_d_fa_system|_d_fa_hidden,%cx
   dos_findfirst
  jc 999f
0: call process_dir_entry
  dos_findnext
  jnc 0b
999:
  xpopregs %cx,%bx
  ret
process_dir_entry:
   xpushregs %bx
  lfs dta,%bx
  mov %fs:_d_ffblk_attr(%bx),%al
   if_z just_dirs,0f,b
   if_unset $_d_fa_direc,%al,999f
  jmp 1f
0: if_nz also_dirs,1f,b
   if_set $_d_fa_direc,%al,999f
1:  if_z just_arch,0f,b
  if_unset $_d_fa_arch,%al,999f
0:  if_z just_rdonly,0f,b
  if_unset $_d_fa_rdonly,%al,999f
0:  if_z just_system,0f,b
  if_unset $_d_fa_system,%al,999f
0:  if_z just_hidden,0f,b
  if_unset $_d_fa_hidden,%al,999f
0:
    lea _d_ffblk_name(%bx),%si
   call is_dot_entry
  jz 999f
  lea output_line,%di
   call _strcpy
   if_z print_size,0f,b
  movb $' ',%al
   stosb
  pushl %fs:_d_ffblk_size(%bx)
   call i2ascl
0: movw $'\n',(%di)
  pushw $output_line
  pushw handle
  call fdprint
999:  xpopregs %bx
ret
is_dot_entry:
   if (%si),e,$0x2e,999f,w
  cmpw $0x2e2e,(%si)
999:
  ret
  parse_args
  getoptitem s,print_size,"print size"
  getoptitem D,just_dirs,"only dirs"
  getoptitem A,just_arch,"print archive"
  getoptitem S,just_system,"print system"
  getoptitem H,just_hidden,"print system"
  getoptitem R,just_rdonly,"print rdonly"
  getoptvalue o,get_ofn,"output file name"
  getoptitem d,also_dirs,"also dirs as well as files"
  parse_args_term
get_ofn:
  lea ofn,%di
  call strcpy_
  ret
_strcpy:
  push %fs
0:   lodsb %fs:(%si)
  if_z %al,999f
   stosb
  jmp 0b
999:
  pop %si
  ret
.data
handle: .word 0
ofn: .space 0x80
tmpl: .asciz "*.*"
.=tmpl+0x80
print_size: .byte 0
just_dirs: .byte 0
just_arch: .byte 0
just_rdonly: .byte 0
just_hidden: .byte 0
just_system: .byte 0
also_dirs: .byte 0
.bss
dta: .long 0
output_line: .space 40
