# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"
# buils as a dos 16 bit .exe file
# uses same io irq etc as the device driver

_d_sample_rate=11025
_d_mad16_passwd_reg=0xf8f
.macro opti_passwd
  mov $0xe2,%ax
  mov    $_d_mad16_passwd_reg,%dx
  outb %al,(%dx)
.endm

.macro opti_outb n,p
  opti_passwd
  mov \n,%al
  mov \p,%dx
  out    %al,(%dx)
.endm

  jmp l40
.=4
.word 0x8000,0,0
dev_name: .ascii "mztinit"
.org dev_name+8,0x20
l16:.byte 1 # /m sets bit 2 dunno what this means midi? mixer?
l17:  .byte 0x13
l18: .byte 0x80
l19: .byte 0x2
l1a: .byte 0x10
l1b: .byte 0 
l1c: .byte 0
l1d:   .byte 0
 .word 0x100
.word 0x0101,0x0101
.byte 1
l25: .byte 0xb
 .byte 0x82
l27: .byte 2
l28:  .word 0x0000
l2a:  .byte 0
sb_base:  .word 0x220
l2d:  .byte 7
 .word 0x530
l30: .word 0x0534
l32: .word 0x535
l40:
  call pinit
 mov %cs,%ax
  mov %ax,%ds
  mov %ax,%es
  cli
  mov %ax,%ss
  lea stack_end,%sp
  sti
l5e:
  if_z argc,0f,w
  mov argv,%si
  lea fn,%di
  call strcpy_
0:
  xopen_file $fn,$0
  mov %ax,handle
  dos_read handle,%ds,$l796,$max_audio_sz
  mov %ax,audio_len
   dos_close_file handle
  puts "here is this 13"
call   driver_main
  terminate 00

l77:
  opti_outb $0x10,$0xf91
0: _inb l30
  if %al,e,$0x80,0b
  _outb $0xa,l30
  _inb l30
  _outb l27,l32
  _inb l32
  _outb $0xb,l30
  _inb l30
  _outb l28,l32
  _inb l32
  mov l2d,%al
  xor    $0xf,%al
  shl    %al
  or     $0x1,%al
  mov    %al,l2d
  _outb $2,l30
  _inb l30
  _outb l2d,l32
  _inb l32
  _outb $3,l30
  _inb l30
  _outb l2d,l32
  _inb l32
  _outb $4,l30
  _inb l30
  _outb l2d,l32
  _inb l32
  _outb $5,l30
  _inb l30
  _outb l2d,l32
   _inb l32
  _outb $6,l30
  _inb l30
  _outb l2d,l32
  _inb l32
  _outb $7,l30
  _inb l30
  _outb l2d,l32
  _inb l32
  _outb $0,l30
  _inb l30
  _outb $0xa7,l32
  _inb l32
  _outb $1,l30
  _inb l30
  _outb $0xa7,l32
  _inb l32
0:  _inb l30
  if %al,e,$0x80,0b
  _outb $0x48,l30
  _outb l25,l32
0:  _inb l30
  if  %al,e,$0x80,0b

  _outb l1d,l30
  call   do_delay
  opti_outb $0x20,$0xf91
  ret    
l25d: opti_outb l16,$0xf8d
 opti_outb l17,$0xf8e
  opti_outb l18, $_d_mad16_passwd_reg
  opti_outb l19,$0xf90
 opti_outb l1a,$0xf91
 opti_outb l1b,$0xf92
  opti_outb l1c,$0xf93
  ret    
do_delay:  usleep $10
 ret
driver_main:
  opti_outb $0x40,$0xf8d
  opti_outb $0x10,$0xf91
  opti_outb $0,$0xf8d
  call   do_delay
 opti_outb l16,$0xf8d
 sblast_reset sb_base
  mov    $0x3,%bl
  opti_outb %bl,$0xf8e
  opti_passwd
 mov    $0xf8e,%dx
  in     (%dx),%al
  if %al,ne,%bl,0f
  call   l25d
  call   l77
0:
  call   l762
  zeroreg %ax
  ret    
l6f8:push   %ax
  push   %dx
  mov $0x34dd,%ax
  mov    $0x12,%dx
  cmp    %bx,%dx
  jae    l71e
  div    %bx
  mov    %ax,%bx
  in     $0x61,%al
  test   $0x3,%al
  jne    l716
  or     $0x3,%al
  out    %al,$0x61
  mov    $0xb6,%al
  out    %al,$0x43
l716:mov    %bl,%al
  out    %al,$0x42
  mov    %bh,%al
  out    %al,$0x42
l71e:pop    %dx
  pop    %ax
  ret    
reset_kbd:push   %ax
  in     $0x61,%al
  and    $0xfc,%al
  out    %al,$0x61
  pop    %ax
  ret    
set_pit_kbd:push   %ax
  call   l6f8
  in     $0x61,%al
  and    $0xfd,%al
  out    %al,$0x61
  pop    %ax
  ret    
sblast_write_audio:
  cld    
  mov audio_len,%cx
  mov    $l796,%si
0:  sblast_putc $0x10,sb_base
1:  in $0x61,%al
  if_unset $0x20,%al,1b
  lodsb
  sblast_putc %ax,sb_base
1:  in     $0x61,%al
  if_set $0x20,%al,1b
  loop   0b
  ret    
l762:
  pusha
  sblast_reset sb_base
  sblast_spkr sb_base,$1
  mov    $_d_sample_rate,%bx
  call   set_pit_kbd
  call   sblast_write_audio
  call   do_delay
  sblast_spkr sb_base,$0
  call   reset_kbd
  popa
  ret
fn: .asciz "c:\\mzttest.raw"
.=fn+256
.bss
audio_len: .word 0
l796: .space 0x4000
max_audio_sz=.-audio_len
handle: .word 0
  .space 8192
stack_end: .word 0
