# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"
#install as  a  .sys file build to run at org 0
# uses a=220 i=5 dma=1
_d_sample_rate=11025
_d_mad16_passwd_reg=0xf8f

.long -1
.word 0x8000,l35,l40
dev_name: .ascii "mztinit"
.org dev_name+8,0x20
req_hdr:  .long 0
l16:.word 0x1301
l18: .byte 0x80,0x2 
 .word 0x0010,0x0000,0x0100
.word 0x0101,0x0101,0x0b01,0x0282,0x0000
  .byte 0
l2b:  .word 0x220
l2d:  .byte 7
 .word 0x0530
l30: .word 0x0534
l32: .word 0x535
l34:.byte 1
l35:
  mov    %bx,%cs:req_hdr # save request header
  mov    %es,%cs:req_hdr+2
  lret   
l40:
  push   %ax
  push   %bx
  push   %cx
  push   %dx
  push   %si
  push   %di
  push   %ds
  push   %es
  push   %bp
  movseg %cs,%ds
  les  req_hdr,%di
  mov  %es:req_hdr_cmd(%di),%bl
  or     %bl,%bl
  je     l5e
  mov    $0x8003,%ax
  jmp    l66
l5e:call   driver_main
  les    %cs:req_hdr,%di
l66:or     $0x100,%ax
  mov    %ax,%es:0x3(%di)
  pop    %bp
  pop    %es
  pop    %ds
  pop    %di
  pop    %si
  pop    %dx
  pop    %cx
  pop    %bx
  pop    %ax
  lret   
l77:mov    $0xe2,%al
  mov    $_d_mad16_passwd_reg,%dx
  out    %al,(%dx)
l81:mov    $0x10,%al
  mov    $0xf91,%dx
  out    %al,(%dx)
l8b:mov    %cs:l30,%dx
  in     (%dx),%al
  cmp    $0x80,%al
  je     l8b
  mov    $0xa,%al
  mov    %cs:l30,%dx
  out    %al,(%dx)
la1:in     (%dx),%al
la6:mov    0x27,%al
  mov    %cs:l32,%dx
  out    %al,(%dx)
lb3:in     (%dx),%al
lb8:mov    $0xb,%al
  mov    %cs:l30,%dx
  out    %al,(%dx)
lc4:in     (%dx),%al
lc9:mov    0x28,%al
  mov    %cs:l32,%dx
  out    %al,(%dx)
ld6:in     (%dx),%al
ldb:mov    %cs:l2d,%al
  xor    $0xf,%al
  shl    %al
  or     $0x1,%al
  mov    %al,%cs:l2d
  mov    $0x2,%al
  mov    %cs:l30,%dx
  out    %al,(%dx)
lf5:in     (%dx),%al
lfa:mov    %cs:l2d,%al
  mov    %cs:l32,%dx
  out    %al,(%dx)
l108:in     (%dx),%al
l10d:mov    $0x3,%al
  mov    %cs:l30,%dx
  out    %al,(%dx)
l119:in     (%dx),%al
l11e:mov    %cs:l2d,%al
  mov    %cs:l32,%dx
  out    %al,(%dx)
l12c:in     (%dx),%al
l131:mov    $0x4,%al
  mov    %cs:l30,%dx
  out    %al,(%dx)
l13d:in     (%dx),%al
l142:mov    %cs:l2d,%al
  mov    %cs:l32,%dx
  out    %al,(%dx)
l150:in     (%dx),%al
l155:mov    $0x5,%al
  mov    %cs:l30,%dx
  out    %al,(%dx)
l161:in     (%dx),%al
l166:mov    %cs:l2d,%al
  mov    %cs:l32,%dx
  out    %al,(%dx)
l174:in     (%dx),%al
l179:mov    $0x6,%al
  mov    %cs:l30,%dx
  out    %al,(%dx)
l185:in     (%dx),%al
l18a:mov    %cs:l2d,%al
  mov    %cs:l32,%dx
  out    %al,(%dx)
l198:in     (%dx),%al
l19d:mov    $0x7,%al
  mov    %cs:l30,%dx
  out    %al,(%dx)
l1a9:in     (%dx),%al
l1ae:mov    %cs:l2d,%al
  mov    %cs:l32,%dx
  out    %al,(%dx)
l1bc:in     (%dx),%al
l1c1:mov    $0x0,%al
  mov    %cs:l30,%dx
  out    %al,(%dx)
l1cd:in     (%dx),%al
l1d2:mov    $0xa7,%al
  mov    %cs:l32,%dx
  out    %al,(%dx)
l1de:in     (%dx),%al
l1e3:mov    $0x1,%al
  mov    %cs:l30,%dx
  out    %al,(%dx)
l1ef:in     (%dx),%al
l1f4:mov    $0xa7,%al
  mov    %cs:l32,%dx
  out    %al,(%dx)
l200:in     (%dx),%al
l205:mov    %cs:l30,%dx
  in     (%dx),%al
  cmp    $0x80,%al
  je     l205
  mov    $0x48,%al
  mov    %cs:l30,%dx
  out    %al,(%dx)
  mov    0x25,%al
  mov    %cs:l32,%dx
  out    %al,(%dx)
l220:mov    %cs:l30,%dx
  in     (%dx),%al
  cmp    $0x80,%al
  je     l220
  mov    %cs:l30,%dx
  mov    0x1d,%al
  out    %al,(%dx)
  call   l2f1
  mov    $0xe2,%al
  mov    $_d_mad16_passwd_reg,%dx
  out    %al,(%dx)
l240:mov    $0x20,%al
  mov    $0xf91,%dx
  out    %al,(%dx)
l24a:ret    
sblast_reset:mov    %cs:l2b,%dx
  add    $0x6,%dx
  mov    $0x1,%al
  out    %al,(%dx)
  mov    $0x0,%al
  out    %al,(%dx)
  call   l2f1
  ret    
l25d:mov    $0xe2,%al
  mov    $_d_mad16_passwd_reg,%dx
  out    %al,(%dx)
  jmp    l265
l265:jmp    l267
l267:mov    l16,%al
  mov    $0xf8d,%dx
  out    %al,(%dx)
  jmp    l270
l270:jmp    l272
l272:mov    $0xe2,%al
  mov    $_d_mad16_passwd_reg,%dx
  out    %al,(%dx)
  jmp    l27a
l27a:jmp    l27c
l27c:mov    0x17,%al
  mov    $0xf8e,%dx
  out    %al,(%dx)
  jmp    l285
l285:jmp    l287
l287:mov    $0xe2,%al
  mov    $_d_mad16_passwd_reg,%dx
  out    %al,(%dx)
  jmp    l28f
l28f:jmp    l291
l291:mov    l18,%al
  mov    $_d_mad16_passwd_reg,%dx
  out    %al,(%dx)
  jmp    l29a
l29a:jmp    l29c
l29c:mov    $0xe2,%al
  mov    $_d_mad16_passwd_reg,%dx
  out    %al,(%dx)
  jmp    l2a4
l2a4:jmp    l2a6
l2a6:mov    0x19,%al
  mov    $0xf90,%dx
  out    %al,(%dx)
  jmp    l2af
l2af:jmp    l2b1
l2b1:mov    $0xe2,%al
  mov    $_d_mad16_passwd_reg,%dx
  out    %al,(%dx)
  jmp    l2b9
l2b9:jmp    l2bb
l2bb:mov    0x1a,%al
  mov    $0xf91,%dx
  out    %al,(%dx)
  jmp    l2c4
l2c4:jmp    l2c6
l2c6:mov    $0xe2,%al
  mov    $_d_mad16_passwd_reg,%dx
  out    %al,(%dx)
  jmp    l2ce
l2ce:jmp    l2d0
l2d0:mov    0x1b,%al
  mov    $0xf92,%dx
  out    %al,(%dx)
  jmp    l2d9
l2d9:jmp    l2db
l2db:mov    $0xe2,%al
  mov    $_d_mad16_passwd_reg,%dx
  out    %al,(%dx)
  jmp    l2e3
l2e3:jmp    l2e5
l2e5:mov    0x1c,%al
  mov    $0xf93,%dx
  out    %al,(%dx)
  jmp    l2ee
l2ee:jmp    l2f0
l2f0:ret    
l2f1:push   %ax
  push   %cx
  mov    $0xffff,%cx
l2f6:in     $0x61,%al
  and    $0x10,%al
  cmp    %ah,%al
  je     l2f6
  mov    %al,%ah
  loop   l2f6
  pop    %cx
  pop    %ax
  ret    
driver_main:push   %es
  push   %di
  call   parse_cmdline
  mov $0xe2,%ax
  mov    $_d_mad16_passwd_reg,%dx
  out    %al,(%dx)
l31a:mov    $0x40,%al
  mov    $0xf8d,%dx
  out    %al,(%dx)
l324:mov    $0xe2,%al
  mov    $_d_mad16_passwd_reg,%dx
  out    %al,(%dx)
l32e:mov    $0x10,%al
  mov    $0xf91,%dx
  out    %al,(%dx)
l338:mov    $0xe2,%al
  mov    $_d_mad16_passwd_reg,%dx
  out    %al,(%dx)
l342:mov    $0x0,%al
  mov    $0xf8d,%dx
  out    %al,(%dx)
l34c:call   l2f1
  mov    $0xe2,%al
  mov    $_d_mad16_passwd_reg,%dx
  out    %al,(%dx)
l359:mov    l16,%al
  mov    $0xf8d,%dx
  out    %al,(%dx)
l368:call   sblast_reset
  mov    $0x3,%bl
  mov    $0xe2,%al
  mov    $_d_mad16_passwd_reg,%dx
  out    %al,(%dx)
l37d:mov    %bl,%al
  mov    $0xf8e,%dx
  out    %al,(%dx)
l387:mov    $0xe2,%al
  mov    $_d_mad16_passwd_reg,%dx
  out    %al,(%dx)
l391:mov    $0xf8e,%dx
  in     (%dx),%al
l399:cmp    %bl,%al
  je     l3a0
  jmp    l3ac
l3a0:
  call   l25d
  call   l77
l3ac:pop    %di
  pop    %es
  push   %bp
  push   %si
  push   %di
  push   %ds
  push   %es
  movseg %cs,%ds
  call   l762
  pop    %es
  pop    %ds
  pop    %di
  pop    %si
  pop    %bp
  les    %cs:req_hdr,%di
  movw  $driver_main,%es:0xe(%di)
  mov    %cs,%es:0x10(%di)
  xor    %ax,%ax
  ret    
parse_cmdline:push   %es
  push   %si
  les    %es:0x12(%di),%si
l3f6:mov    %es:(%si),%al
  if %al,e,$'\r',l51a
  if %al,e,$'\n',l51a
call   skip_wspace
  if %es:(%si),e,$'/',l413,b
  inc    %si
  jmp    l3f6
l413:inc    %si
  call   skip_wspace
  if %es:(%si),ne,$'a',0f,b
  call   l56f
  jmp    l3f6
0:  if %es:(%si),ne,$'i',0f,b
  call   l59c
  jmp    l3f6
0:  if %es:(%si),ne,$'d',0f,b
  call   l5d0
  jmp    l3f6
0:cmpb   $0x4d,%es:(%si)
  jne    l467
  orb    $0x4,%cs:l16
  jmp    l3f6
l467:cmpb   $0x6d,%es:(%si)
  jne    l475
  orb    $0x4,%cs:l16
  jmp    l3f6
l475:cmpb   $0x53,%es:(%si)
  jne    l484
  orb    $0x2,%cs:l16
  jmp    l3f6
l484:cmpb   $0x73,%es:(%si)
  jne    l493
  orb    $0x2,%cs:l16
  jmp    l3f6
l493:cmpb   $0x50,%es:(%si)
  jne    l4a2
  orb    $0x2,%cs:l16
  jmp    l3f6
l4a2:cmpb   $0x70,%es:(%si)
  jne    l4b1
  orb    $0x2,%cs:l16
  jmp    l3f6
l4b1:cmpb   $0x43,%es:(%si)
  jne    l4bd
  call   l5f9
  jmp    l3f6
l4bd:cmpb   $0x63,%es:(%si)
  jne    l4c9
  call   l5f9
  jmp    l3f6
l4c9:cmpb   $0x56,%es:(%si)
  jne    l4d5
  call   l533
  jmp    l3f6
l4d5:cmpb   $0x76,%es:(%si)
  jne    l4e1
  call   l5bf
  jmp    l3f6
l4e1:cmpb   $0x4f,%es:(%si)
  jne    l4ed
  call   l5bf
  jmp    l3f6
l4ed:cmpb   $0x6f,%es:(%si)
  jne    l4f9
  call   l533
  jmp    l3f6
l4f9:cmpb   $0x47,%es:(%si)
  jne    l508
  andb   $0xfe,%cs:l16
  jmp    l3f6
l508:cmpb   $0x67,%es:(%si)
  je     l511
  jmp    l3f6
l511:andb   $0xfe,%cs:l16
  jmp    l3f6
l51a:mov    %cs:l16,%al
  and    $0xe,%al
  cmp    $0x0,%al
  jne    l530
  andb   $0xe3,%cs:0x17
  orb    $0x3,%cs:0x17
l530:pop    %si
  pop    %es
  ret    
l533:inc    %si
  mov    %es:(%si),%ah
  inc    %si
  mov    %es:(%si),%al
  cmp    $0x30,%al
  jb     l555
  cmp    $0x39,%al
  ja     l555
  sub    $0x30,%al
  mov    %al,%cs:l2d
  cmp    $0x31,%ah
  jne    l568
  addb   $0xa,%cs:l2d
  ret    
l555:cmp    $0x30,%ah
  jb     l568
  cmp    $0x39,%ah
  ja     l568
  sub    $0x30,%ah
  mov    %ah,%cs:l2d
  ret    
l568:movb   $0x5,%cs:l2d
  ret    
l56f:inc    %si
  call   skip_wspace
  cmpb   $'2',%es:(%si)
  jne    l59b
  inc    %si
  cmpb   $'4',%es:(%si)
  jne    l59b
  orb    $0x20,%cs:l16
  movw   $0x240,%cs:l2b
  movw   $0xf44,%cs:l30
  movw   $0xf45,%cs:l32
l59b:ret    
l59c:inc    %si
  call   skip_wspace

  if %es:(%si),ne,$'7',l5ac,b
  andb   $0x3f,%cs:l18
l5ac:cmpb   $0x31,%es:(%si)
  jne    l5be
  andb   $0x3f,%cs:l18
  orb    $0x40,%cs:l18
l5be:ret    
l5bf:inc    %si
  call   skip_wspace
  cmpb   $'4',%es:(%si)
  jne    l5cf
  orb    $0x20,%cs:0x17
l5cf:ret    
l5d0:inc    %si
  call   skip_wspace
  if  %es:(%si),ne,$'2',l5e6,b
  andb   $0xcf,%cs:l18
  orb    $0x10,%cs:l18
l5e6: if %es:(%si),ne,$'3',l5f8,b
  andb   $0xcf,%cs:l18
  orb    $0x20,%cs:l18
l5f8:ret    
l5f9:inc    %si
  call   skip_wspace
  cmpb   $0x41,%es:(%si)
  jne    l634
l603:inc    %si
  call   skip_wspace
  cmpb   $'3',%es:(%si)
  jne    l620
  inc    %si
  cmpb   $'2',%es:(%si)
  jne    l621
  andb   $0x3f,%cs:0x17
  orb    $0xc0,%cs:0x17
l620:ret    
l621:cmpb   $'3',%es:(%si)
  jne    l620
  andb   $0x3f,%cs:0x17
  orb    $0x40,%cs:0x17
  ret    
l634:cmpb   $0x61,%es:(%si)
  jne    l63c
  jmp    l603
l63c:cmpb   $0x49,%es:(%si)
  jne    l673
l642:inc    %si
  call   skip_wspace
  cmpb   $0x31,%es:(%si)
  jne    l620
  inc    %si
  cmpb   $0x30,%es:(%si)
  jne    l660
  andb   $0xe3,%cs:0x17
  orb    $0x14,%cs:0x17
  ret    
l660:cmpb   $'1',%es:(%si)
  jne    l620
  andb   $0xe3,%cs:0x17
  orb    $0x18,%cs:0x17
  ret    
l673:cmpb   $0x69,%es:(%si)
  jne    l67b
  jmp    l642
l67b:ret    
skip_wspace:cmpb   $0x20,%es:(%si)
  je     l68a
  cmpb   $0x9,%es:(%si)
  je     l68a
  jmp    l68d
l68a:inc    %si
  jmp    skip_wspace
l68d:ret    
  push   %ax
  push   %dx
  mov    $0x505,%ax
l693:mov    $0xe2,%al
  mov    $_d_mad16_passwd_reg,%dx
  out    %al,(%dx)
  jmp    l69b
l69b:jmp    l69d
l69d:mov    %al,%al
  mov    $0xf8e,%dx
  out    %al,(%dx)
  jmp    l6a5
l6a5:jmp    l6a7
l6a7:mov    $0xe2,%al
  mov    $_d_mad16_passwd_reg,%dx
  out    %al,(%dx)
  jmp    l6af
l6af:jmp    l6b1
l6b1:mov    $0xf8e,%dx
  in     (%dx),%al
  jmp    l6b7
l6b7:jmp    l6b9
l6b9:cmp    %ah,%al
  jne    l6c9
  not    %ax
  and    $0xf0f,%ax
  cmp    $0x505,%ax
  je     l6c9
  jmp    l693
l6c9:pop    %dx
  pop    %ax
  ret    
sblast_read_byte:push   %dx
  mov    %cs:l2b,%dx
  add    $0xe,%dx
l6d5:in     (%dx),%al
  test   $0x80,%al
  je     l6d5
  mov    %cs:l2b,%dx
  add    $0xa,%dx
  in     (%dx),%al
  pop    %dx
  ret    
sblast_write_byte:push   %dx
  push   %ax
  mov    %cs:l2b,%dx
  add    $0xc,%dx
l6ef:in     (%dx),%al
  test   $0x80,%al
  jne    l6ef
  pop    %ax
  out    %al,(%dx)
  pop    %dx
  ret    
l6f8:push   %ax
  push   %dx
  mov $0x34dd,%ax
  mov    $0x12,%dx
  cmp    %bx,%dx
  jae    l71e
  div    %bx
  mov    %ax,%bx
  in     $0x61,%al
  test   $0x3,%al
  jne    l716
  or     $0x3,%al
  out    %al,$0x61
  mov    $0xb6,%al
  out    %al,$0x43
l716:mov    %bl,%al
  out    %al,$0x42
  mov    %bh,%al
  out    %al,$0x42
l71e:pop    %dx
  pop    %ax
  ret    
reset_kbd:push   %ax
  in     $0x61,%al
  and    $0xfc,%al
  out    %al,$0x61
  pop    %ax
  ret    
set_pit_kbd:push   %ax
  call   l6f8
  in     $0x61,%al
  and    $0xfd,%al
  out    %al,$0x61
  pop    %ax
  ret    
sblast_write_audio:push   %ax
  push   %dx
  push   %ds
movseg %cs,%ds
  cld    
  mov    $audio_end-l796,%cx
  mov    $l796,%si
l743:mov    $0x10,%al
  call   sblast_write_byte
l748:mov    $0x61,%dx
  in     (%dx),%al
  test   $0x20,%al
  je     l748
  lods   %ds:(%si),%al
  call   sblast_write_byte
l754:mov    $0x61,%dx
  in     (%dx),%al
  test   $0x20,%al
  jne    l754
  loop   l743
  pop    %ds
  pop    %dx
  pop    %ax
  ret    
l762:push   %ax
  push   %bx
  push   %dx
  mov    %cs:l2b,%dx
  add    $0x6,%dx
  mov    $0x1,%al
  out    %al,(%dx)
  call   l2f1
  mov    $0x0,%al
  out    %al,(%dx)
  call   sblast_read_byte
  mov    $0xd1,%al
  call   sblast_write_byte
  mov    $_d_sample_rate,%bx
  call   set_pit_kbd
  call   sblast_write_audio
  call   l2f1
  mov    $0xd3,%al
  call   sblast_write_byte
  call   reset_kbd
  pop    %dx
  pop    %bx
  pop    %ax
  ret    
l796:
.incbin "mztinit-data.s"
audio_end:
