# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

.macro bx_call n
mov $bx_call_\@,%bx
  jmp \n
bx_call_\@:
.endm

.macro di_call n
mov $di_call_\@,%di
  jmp \n
di_call_\@:
.endm

.macro si_call n
mov $si_call_\@,%si
  jmp \n
si_call_\@:
.endm


.macro otrbios_exit rc,msg
   set_segs %cs
  lea -2,%sp
 exit_msg \rc,"\msg\nztter"
.endm

.macro int3
 int $0x3
.endm

.macro die_at n
l\n:  otrbios_exit $1,"\n"
.endm

.macro pci2isa_eio_read_byte ch
  mov \ch,%al
  bx_call l4280
.endm

.macro pci2isa_eio_write_byte at,val
.ifnb \at
  mov \at,%al
.endif
.ifnb \val
  mov \val,%ah
.endif
  bx_call l4286
.endm

.macro pci_pm_read_byte ch
  mov \ch,%al
  bx_call l5375
.endm

.macro save_seg n
  mov %\n,%cs:save_\n
.endm
.macro print_msg  str
.data
print_msg\@: .asciz "\str"
.text
  pushw $print_msg\@
  call print_msg
.endm
.macro cmos_foo d
  mov \d,%dx
  di_call l38d9
.endm
