# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"
.include "sect.h"
.global _start
numsecs=1

_start:
  process_cmdline fn,drive,start_sector,num_sectors,"Read file from"
100:  lea fn,%dx
  xor %cx,%cx
  dos_create_file
  jnc get_drive_parms 
  print "Unable to open file: "
  lea fn,%si
  call dos_print
  print " for writing error="
  mov %ax,%dx
  call hexoutword
  dos_writedl_con $'\n'
  terminate 01
get_drive_parms:
  mov %ax,handle
  get_drive_parms_die_on_error drive
  store_drive_parms max_cyls,sectors_per_track,max_heads,sectors_per_cyl
  mov start_sector,%ax
  mov num_sectors,%cx
100:
  call process_sector
  inc %ax
  loop 100b
  mov handle,%bx
  dos_close_file
  terminate 00

process_sector:
  push %ax
  push %cx
setup_int13_parms drive,%ax,$numsecs,  sectors_per_cyl,sectors_per_track
  movseg_offs %cs,$bootsect,%es,%bx
  read_sector
  jnc 100f 
 print "Error reading secgtor rc="
 mov %ah,%dl
  call hexoutchar
   dos_writedl_con $'\n' 
  terminate 01
100:
  mov handle,%bx 
mov $0x200,%cx
  lea bootsect,%dx
  dos_write_handle
  jnc 100f
  print "Error writing file"
  lea fn,%si
  call dos_puts
  terminate 01
100:
  pop %cx
  pop %ax
  ret

drive: .byte 0
start_sector: .word 1
num_sectors: .word 1
max_cyls: .word 0
sectors_per_cyl: .word 0
sectors_per_track: .byte 0
max_heads: .byte 0
handle: .word 0
fn: .fill 128
bootsect: .fill 512
