# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"
load_seg=0x6000

.macro dma_start dma,addr,sz,loop,dir
  push \dir
  push \loop
  push \sz
  pushl \addr
  push \dma
  call32 dma_start
.endm

.macro sblast_dac_spkr io,on_off
  push \on_off
  push \io
  call32 sblast_dac_spkr
.endm
  xopen_file $fn,$0
  mov %ax,handle
  ext_read handle,$load_seg<<4,$-1
  mov %ax,buf_sz
  dos_close_file handle
 exhibit $1,16,buf_sz

  mov $0x100,%ax
  sub $1000/11025,%ax
  mov %al,time_constant
 printreg ax $'\n'

    sblast_reset sb_io_base

 mov sb_irq,%ax
  add $8,%al
  get_vector sb_irq
  mov %eax,old_hdlr+1
  set_irq $0x21,sb_irq,$0
  mov %al,old_irq
  sblast_dac_spkr  sb_io_base,$1
  dma_start sb_dma,$load_seg<<4,buf_sz,$1,$0
 ind_outb $0x40,sb_io_base,$0xc
 ind_outb time_constant,sb_io_base,$0xc

  ind_outb $0x14,sb_io_base,$0xc
  ind_outb buf_sz,sb_io_base,$0xc
 ind_outb buf_sz+1,sb_io_base,$0xc
  sleep $2
  sblast_dac_spkr sb_io_base,$0
   set_vector sb_irq,old_hdlr+1
  _outb old_irq,$0x21
  puts "wibble we seem to be ok so far"
  terminate 00
int_hdlr:
  mov %ss,%cs:save_ss
  mov %sp,%cs:save_sp
  cli
  mov %cs,%sp
 mov %sp,%ss
   lea mini_stack,%sp
  sti
  pusha
 xpushregs %ds,%es
 mov %cs,%ax
  mov %ax,%ds
  mov %ax,%es
# sb  stuff starts here
  mov sb_io_base,%dx
  add $4,%dl
  mov $0x82,%al
 out %al,(%dx)
  inc %dl
  in (%dx),%al
 printreg ax $'\n'
 xpopregs %es,%ds
  popa
  cli
 lss %cs:save_sp,%sp
  sti
old_hdlr:  .byte 0xea,0,0,0,0
sb_io_base: .word 0x220
sb_irq: .byte 5
sb_dma: .byte 1
fn: .asciz "c:\\mozart\\test8.wav"
.bss
time_constant: .byte 0
handle: .word 0
buf_sz: .word 0
save_sp: .word 0
save_ss: .word 0
old_irq: .byte 0
 .space 8192
mini_stack: .word 0
.text
.struct 2*sizeof_int
dac_spkr_io: int_t 0
dac_spkr_on_off: int_t 0
estruct
gsym sblast_dac_spkr _enter
  pusha
   mov dac_spkr_on_off(_bp),%al
  not %al
  and $0x1,%al
  shl %al
  or $0xd1,%al
  ind_outb dac_spkr_io(_bp),$0xc,%ax
  popa
  leave 
  ret $ret_sz
.include "dma.s"
