# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

  zeroreg %bx
  mov $0x5300,%ax
  int $0x15
   exit_if_cf $1,"no apm installed"
   printreg ax  $'\n'
  printreg bx $'\n'
  mov %cx,apm_flags
  push %cx
  call print_apm_info
  puts "we are going to sleep"
  playnote_ms $1760,$1000
  mov $1,%bx
  mov $2,%cx
  mov $0x5307,%ax
    int $0x15
  exit_if_cf $1,"it failed"
  playnote_ms $0x440,$0x1000
  puts "back again!"
   terminate 00
print_apm_info: _enter
  pusha
  mov $8,%cx
  lea apm_attrs,%bx
   mov $1,%dl
0: test %dl,4(_bp)
  jz 1f
  mov (%bx),%si
  call dos_puts
1:  shl %dl
  add2 %bx
  loop 0b
  popa
  leave
  ret $sizeof_int
apm_attrs:
strtab  "16-bit protected mode interface supported"
strtab  "32-bit protected mode interface supported"
strtab  "CPU idle call reduces processor speed"
strtab  "BIOS power management disabled"
strtab  "BIOS power management disengaged (APM v1.1)"
strtab  "reserved 1"
strtab  "reserved 2"
strtab  "reserved 3"
.bss
apm_flags: .word 0
