# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"
.include "uhci-mac.h"

  puts "this is now uhci00"
  movw $qtd_array,uhci_qtd_p
call   l7a2c
  call   l42d9
  exit_msg $1,"ok thats all folks"
l7a2c:
    pci16_find_class $_d_pci_uhci_usb_class
   exit_if_cf $1,"no uhci dev found"
   mov %ax,pci_slot
  movb $0,uhci_root_type
     pci16_read_first_ioaddr pci_slot
  and $~3,%ax
   mov %ax,uhci_ioaddr
  uhci_config_usbcmd uhci_ioaddr
  uhci_init_usbintr uhci_ioaddr
 uhci16_init_framelist uhci_ioaddr,$framelist_space
  mov %ax,uhci_hd_p
  uhci_enable_ports uhci_ioaddr
  ret    
l42d9:
  fdhex $1,16,uhci_ioaddr
_outw $0,uhci_ioaddr,$_d_usbintr
  io_setbitsw uhci_ioaddr,$_d_usbcmd,$_d_usbcmd_rs
 
  mov $2,%cx
   zeroreg %bx
0:  call   l3d54
   inc %bx
  loop 0b
  ret    
l3d54:
  pusha

  movb $0,uhci_dev_addr
 uhci_reset_port uhci_ioaddr,%bx
   inc %bl
  movw   $0x8,get_desc+6
  mov %bl,set_addr+2
  do_urb $uhci_usbdev,$set_addr,$l5557,$0,$0
   call dump_qtd
   mov %bl,uhci_dev_addr
   fdputc $' ',$1
    fdhex $1,8,uhci_dev_addr,$' '
  f_memset $l5557,$0,$0x400
  do_urb $uhci_usbdev,$get_desc,$l5557,$0x12,$0
  mov l5557+14,%al
  mov  l5557+15,%al
  mov    %al,l6192
  do_urb $uhci_usbdev,$set_cfg,l5557,$0,$0
  mov $1,%bl
  mov $2,%cx
0:   call dev_str
    inc %bl
  loop 0b
999:
  popa
ret    
dev_str:
  pusha
   f_memset $l5557,$0,$0x400
  mov %bl,get_desc_str+2
  do_urb $uhci_usbdev,$get_desc_str,$l5557,$0xdf,$0
   movzbw l5557,%cx
  lea l5557+2,%si
  call printsw
   dos_newline
  popa
  ret
printsw:
  pusha
   shr %cx
  jz 999f
  cld
0:  lodsw
  dos_writedl_con %al
    loop 0b
999:
  popa
  ret
dump_qtd:
  pushal
     
  mov uhci_qtd_p,%bx
0: hexdumpl $1,%ds,%bx,$0x10
 mov (%bx),%edx
   if_set $1,%dl,999f
  mov %cs,%eax
  shl $4,%eax
   sub %eax,%edx
  mov %dx,%bx
   and $0xf0,%bl
  jmp 0b
999:  popal
  ret
.data
usbdev_t uhci_,urd=uhci_usbrootdev
get_desc: .byte 0x80,0x06,0x00,0x01,0x00,0x00,0x08,0x00
get_desc_str: .byte 0x80,0x06,1,3,0x09,0x04,0xdf,0x00
set_addr: .byte 0x00,0x05,0x01,0x00,0x00,0x00,0x00,0x00
set_cfg:  .byte 0x00,0x09,0x01,0x00,0x00,0x00,0x00,0x00
.bss
port_num: .byte 0
usbrootdev_t uhci_
.align 0x10
qtd_array: .space 0x40
pci_slot: .word 0
l6192: .byte 0
l5557: .space 0x400
framelist_space: .space 8192
