# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

.macro print_info offs,l,s
     fdprint handle,"\s "
     fdi2asc handle,\l,\offs(%si),$'\n'
.endm
 init_args
  arg_value o,"output file"
    lea ofn,%di
   call strcpy_
  ret
.data
ofn: .space 0x80
  init_args_term

  push $0
  push $ofn
  call xcreate_file
   mov %ax,handle

  mov argc,%cx
  lea argv,%bx
    if_nz argc,0f,w
   mov handle,%cx
   jmp 1f
0:    mov (%bx),%si
  call strtoul_
   mov %al,drive
1:  call process_disc
  add $sizeof_int,%bx
  loop 0b

exit_prog: mov handle,%bx
  dos_close_file
   dos_exit
  mov exit_rc,%al

process_disc:
  fdprint handle,"drive: "
  fdhex handle,8,drive,$'\n'
   mov drive,%dl
  lea buf,%si
   ext_drive_parms
  jnc 0f
   fdprint handle,"failed\n"
  movb $1,exit_rc
   jmp exit_prog
0:
   print_info 4,l,"cylinders"
   print_info 8,l,"heads"
   print_info 0xc,l,"secs"
   print_info 0x10,l,"total sectors"
  print_info 0x18,w,"bytes per sector"
  ret
.data
exit_rc: .byte 0
handle: .word 0x1
drive: .byte 0x80
buf: .word _d_dparms_sig
