# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

  call com_init_mem
  mov %cs,%eax
  shl $4,%eax
  or %eax,code_desc32+2
  or %eax,data_desc32+2

  mov $private_data,%dx
  shr $4,%dx
   add %dx,%ax
   mov %ax,private_data_seg
  zeroreg %cx
 mov    $0x1687,%ax
  int    $0x2f
  if_rz %ax,0f
  exit_msg $1,"no dpmi support"
0: shl $4,%si
  if %si,ae,$private_data_l,0f
  exit_msg $1,"need more private data"
0:
  mov %di,modesw
   mov %es,modesw+2
  mov private_data_seg,%ax
  mov %ax,%es
  mov $1,%ax
  cld
   lcall *(modesw)
   cli
  mov %ds,%eax
 mov %eax,%es
  mov %ax,%fs
  mov %ax,%ss
  lea mini_stack,%esp
  sti
  mov %cs,code16_sel
 dpmi_alloc_ldt $1
   mov %ax,code32_sel
  dpmi_alloc_ldt $1
 mov %ax,data32_sel
   dpmi_alloc_ldt $1
 mov %ax,bios16_sel
 dpmi_set_descriptor %ax,$bios_desc16
 dpmi_set_descriptor code32_sel,$code_desc32
 dpmi_set_descriptor data32_sel,$data_desc32
  mov data32_sel,%fs
 mov %fs:test_sig,%ax
  printreg ax $'\n'
 flip_cs code32_sel
.code32
  flip_cs code16_sel
.code16
 exit_msg $1,"ok and out"

test_sig: .word 0x1234
bios_desc16: .word 0xffff,0x400,0xf200,0
code_desc32: .word 0xffff,0,0xfa00,0x40
data_desc32: .word 0xffff,0,0xf200,0x40
.bss
code16_sel: .word 0
bios16_sel: .word 0
code32_sel: .word 0
data32_sel: .word 0
modesw: .long 0
private_data_seg: .word 0
.align 0x10
private_data: .space 4*16
private_data_l=.-private_data
  .space 16384
mini_stack: .long 0
