# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "comint.h"

   init_args
   arg_value d,"baud divisor"
   call stowd
  mov %al,divisor
   ret
.data
divisor: .byte 12
  arg_item v,verbose,"be verbose"
   arg_value o,"output file"
  lea ofn,%di
  call strcpy_
  ret
.data
ofn: .space 0x80
   init_args_term
  push $0
  call port2uart
  mov %ax,port_uart

  serial_config port_uart,divisor

  push $1
   push %cs
  push $int8_handler
  push port_uart
  call enable_com1_hdlr

0:  if_kbhit 1f
 pause
  jmp 0b
1:

   push port_uart
  call disable_com1_hdlr
  terminate 00

int8_handler:
   pusha
  xpushregs %ds,%es
  pushf
  movseg %cs,%ds
  movseg %cs,%es
 playnote_ms $440,$500
  _inb port_uart
  _outb $0x64,$0x20
  popf
  movzbw %al,%ax
   printreg ax $'\n'
  f_spawn $cmdline
  xpopregs %es,%ds
  popa
  iret
.data
cmdline: .asciz "zh.com"
.bss
port_uart: .word 0
