# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "comint.h"

   init_args
   arg_value d,"baud divisor"
   call stowd
  mov %al,divisor
   ret
.data
divisor: .byte 12
  arg_item v,verbose,"be verbose"
   init_args_term

   lea image_end,%bx
   shr $4,%bx
     inc %bx
  dos_resize_memory
  push $0
  call port2uart
  mov %ax,port_uart

  serial_config port_uart,divisor

  push $1
   push %cs
  push $int8_handler
  push port_uart
  call enable_com1_hdlr
  dos_terminate_stay_resident $0,$image_end

   push port_uart
  call disable_com1_hdlr
  terminate 00

int8_handler:
  mov %ss,%cs:save_ss+2
   mov %sp,%cs:save_ss
    cli
   mov %ax,%cs:save_ax
  mov %cs,%ax
  mov %ax,%ss
  lea stack_end,%sp
  mov %cs:save_ax,%ax
  sti
   pusha
  xpushregs %ds,%es
  pushf
  mov %cs,%ax
  mov %ax,%ds
  mov %ax,%es
 playnote_ms $440,$500
  _inb port_uart
  _outb $0x64,$0x20
  popf
  xpopregs %es,%ds
  popa
  cli
  lss %cs:save_ss,%sp
   sti
  iret
.data
cmdline: .asciz "zh.com"
.bss
port_uart: .word 0
save_ss: .long 0
save_ax: .word 0
  .space 0x1000
stack_end:
