# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"
  init_args
  arg_value d,"divisor "
   call strtoul_
   mov %ax,divisor
  ret
.data
divisor: .byte 0xc
   arg_value o,"output file"
  lea ofn,%di
    call strcpy_
  ret
.data
  arg_value p,"com port 1..n"
   call strtoul_
  dec %ax
      push %ax
  call port2uart
  mov %ax,port_uart
ret
.data
port_uart: .word 0x3f8
ofn: .space 0x80
  init_args_term
   
  pushw divisor
  pushw port_uart
  call serial_config

  push $0
  pushw $ofn
  call xcreate_file
  mov %ax,handle

   fdprint handle,"log opened on uart 0x"
  fdhex handle,16,port_uart,$' '
  fdprint handle,"port baud rate divisor=0x"
  fdhex handle,4,divisor,$'\n'
0:  bios_check_keystroke
  jnz  999f
   mov port_uart,%dx
 add $_d_lsr,%dx
 in (%dx),%al
  if_unset $1,%al,0b
  mov port_uart,%dx
  in (%dx),%al
   fdputc %ax,handle
  jmp 0b
999:  fdprint handle,"log closed"
 mov handle,%bx
  dos_close_file
  terminate 00
.data
handle: .word 0
