# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

  port2uart $0
  mov %ax,uart
   serial_config  uart,$1
  serial_mcr uart,$3
  call get_system_time_ms
  mov %eax,start_time
1:  bios_check_keystroke
  jnz 999f
  serial_getch uart,$200
   if %ax,ne,$_d_serial_time_out,0f
   call print_status
   call get_system_time_ms
  mov %eax,start_time
  movl $0,num_bytes
    jmp 1b
0:  incl num_bytes
    jmp 1b
999: call print_status
  serial_config uart,$12
 terminate 00
print_status:
    if_z num_bytes,999f,l
   call get_system_time_ms
   sub start_time,%eax
   zeroreg %edx
  mov $1000,%ecx
   div %ecx
   mov %eax,%ecx
   zeroreg %edx
   mov num_bytes,%eax
    div %ecx     
  mov %eax,%edx
   do_fd $1,"num chars=",i2asc,l,num_bytes,$'\n'
  do_fd $1,"secs=",i2asc,l,%ecx,$'\n'
   do_fd $1,"bps=",i2asc,l,%edx,$'\n'
999:  ret
.data
start_time: .long 0
num_bytes: .long 0
.bss
uart: .word 0
