# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

_d_int=0x10
_d_kbd_vec=0x16

  port2uart port
  mov %ax,uart
 serial_config uart,$0xc

  get_vector $0x15
  mov %eax,int15_old_hdlr+1
  set_vector $0x15,%cs,$int15_hdlr
    get_vector $_d_int
  mov %eax,old_hdlr+1
   set_vector $_d_int,%cs,$int10_hdlr
  dos_terminate_stay_resident $0,$image_end

int15_hdlr:
  if %ah,ne,$0x4f,int15_old_hdlr
  if %al,ne,$0x9d,int15_old_hdlr # the up bit of a ctrl press
 mov %ax,%cs:int15_save_ax
  push %fs
  mov $0x40,%ax
  mov %ax,%fs
  mov %fs:0x18,%al
   mov  %sp,%cs:int15_save_sp
  mov %ss,%cs:int15_save_sp+2
    if_unset $1,%al,999f
  cli
    mov %cs,%ax
  mov %ax,%ss
  lea mini_stack,%sp
   sti
  pusha
  xpushregs %ds,%es
  mov %ax,%ds
  mov %ax,%es
  serial_putc $0x18,uart
  xpopregs %es,%ds
  popa
   lss %cs:int15_save_sp,%sp
999:  xpopregs %fs
 mov %cs:int15_save_ax,%ax
int15_old_hdlr: ljmp $0,$0
.bss
int15_save_sp: .long 0
int15_save_ax: .word 0
.text

int10_hdlr:
  if_nz %cs:on_the_go,old_hdlr,b
 mov %sp,%cs:save_sp
  mov %ss,%cs:save_sp+2
  if %ah,e,$0xe,0f
   if %ah,e,$0x13,0f
  jmp old_hdlr
0: movb $1,%cs:on_the_go
 mov %ax,%cs:save_ax
  mov %cx,%cs:save_cx
  mov %bp,%cs:save_bp
 mov %es,%cs:save_es
  cli
  mov %cs,%ax
 mov %ax,%ss
  lea mini_stack,%sp
  sti
 pusha
   xpushregs %ds,%es
 mov %ax,%ds
 mov %ax,%es
  mov save_ax,%ax
   if %ah,e,$0x13,0f
  serial_putc %ax,uart
 jmp 999f
0:   call write_string
999:  xpopregs %es,%ds
 popa
 lss %cs:save_sp,%sp
  mov %cs:save_ax,%ax
 movb $0,%cs:on_the_go
  iret
old_hdlr: ljmp $0,$0
write_string:
 mov save_bp,%si
  mov save_ax,%dl
  mov save_es,%fs
  mov save_cx,%cx
0:   if_set $2,%dl,1f
  lodsb %fs:(%si)
  jmp 2f
1:   lodsw %fs:(%si)
2:
  serial_putc %ax,uart
  loop 0b
   ret

on_the_go: .byte 0
port: .word 0
.bss
kbd_old_ret_addr: .long 0
kbd_caller_flags: .word 0
kbd_save_ax: .word 0
kbd_save_sp: .long 0
uart: .word 0
save_ax: .word 0
save_cx: .word 0
save_bp: .word 0
save_es: .word 0
save_sp: .long 0
 .space 0x4000
mini_stack: .word 0
