# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"
.include "ehci-mac.h"

   puts "running new ehci do urb"
  f_memset $ehci00_bss_start,$0,$ehci00_bss_sz
  ehci16_setup_q_ptrs $l590,$ehci_hd_p,$ehci_qtd_p
  ehci16_init $slot,$regs,$ehci_usbrootdev
  mov %ax,%cx
  extmem_setbits ehci_ioaddr,$_d_ehci_usbcmd,$1
   zeroreg %bx
   mov $_d_ehci_portsc1,%dx
0:   extmem_read_dword ehci_ioaddr,%dx
  if_unset $1,%al,1f
  call l42d9
1:  add $4,%dx
  inc %bx
  loop 0b
   exit_msg $1,"ok all done"
l42d9:
  pushal
  mov %bx,cur_port
  inc %bx
  do_fd handle,"assigning dev on port ",hex,8,cur_port
   do_fd handle,"to address",hex,8,%ebx,$'\n'

  ehci_reset_port ehci_ioaddr,cur_port
  call   l3d54
  popal
 ret    
l3d54:
  movb $0,ehci_dev_addr
   do_urb $ehci_usbdev,$l5d7b,$l5557,$8,$0
  movzbw    l5557+7,%ax
  mov    l5557+4,%al
  mov  %bl,l5d8b+2
   f_memset $l5557,$0,$0x400
   do_urb $ehci_usbdev,$l5d8b,$l5557,$0,$0
  mov %bl,ehci_dev_addr
  f_memset $l5557,$0,$l5557_sz
   movw $0x12,l5d7b+6
   f_memset $l5557,$0,$0x400
   do_urb $ehci_usbdev,$l5d7b,$l5557,$0x12,$0
  mov    l5557+14,%al
  mov l5557+15,%al
  mov    %al,l6192
  call get_dev_name
   movzbw l5557,%cx
  jcxz 999f
  lea l5557+2,%si
0:  lodsw
    fdputc %ax,$1
  loop 0b
  dos_newline
999:ret    
get_dev_name:
  mov    l6192,%al
  mov    %al,l5d83+2
  f_memset $l5557,$0,$l5557_sz
   do_urb $ehci_usbdev,$l5d83,$l5557,$0xdf,$0
  ret
.data
l6192: .byte 0
cur_port: .byte 0
slot: .word 0
l5d7b:.long 0x01000680,0x00080000
l5d83: .word 0x0680,0x0300,0x0409,0x00df
l5d8b: .word 0x0500,0x0001,0x0000,0x0000
handle: .word 1
usbdev_t ehci_,urd=ehci_usbrootdev
.bss
ehci00_bss_start:
regs: .long 0
usbrootdev_t ehci_
l590: .space 0x1e0
l5557: .space 0x400
l5557_sz=.-l5557
l5957: .space 0x400
ehci00_bss_sz=.-ehci00_bss_start
