# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"
.include "ehci-mac.h"

   puts "running new ehci do urb"
  f_memset $ehci00_bss_start,$0,$ehci00_bss_sz
  ehci16_setup_q_ptrs $l590,$ehci_hd_p,$ehci_qtd_p
  ehci16_init $pci_slot,$regs,$ehci_usbrootdev
  mov %ax,%cx
  extmem_setbits ehci_ioaddr,$_d_ehci_usbcmd,$1
   zeroreg %bx
   mov $_d_ehci_portsc1,%dx
0:   extmem_read_dword ehci_ioaddr,%dx
  if_unset $1,%al,1f
  call l42d9
1:  add $4,%dx
  inc %bx
  loop 0b
   exit_msg $1,"ok all done"
l42d9:
  pushal
  mov %bl,cur_port
  incb cur_dev_addr
  do_fd handle,"assigning dev on port ",hex,8,cur_port
   do_fd handle,"to address",hex,8,cur_dev_addr,$'\n'

  ehci_reset_port ehci_ioaddr,cur_port
  call   l3d54
  popal
 ret    
l3d54:
   usb_set_dev_addr $ehci_usbdev,cur_dev_addr
   usb_get_dev_descriptor $ehci_usbdev,$0,$ehcidev_std_dev_descriptor,$0
  exhibit $1,16,ehcidev_vendor
  exhibit $1,16,ehcidev_product
  mov ehcidev_iproduct,%al
  call get_dev_name
  mov ehcidev_imft,%al
  call get_dev_name
  mov ehcidev_iserial,%al
  call get_dev_name
999:ret    
get_dev_name:
  pusha
   usb_get_string_descriptor $ehci_usbdev,%ax,$l5557,$0xdf,$0
   movzbw l5557,%cx
  jcxz 999f
  lea l5557+2,%si
0:  lodsw
    fdputc %ax,$1
  loop 0b
  dos_newline
999: popa
  ret
.data
cur_port: .byte 0
cur_dev_addr: .byte 0
handle: .word 1
usbdev_t ehci_,urd=ehci_usbrootdev
.bss
ehci00_bss_start:
regs: .long 0
usbrootdev_t ehci_
l590: .space 0x1e0
l5557: .space 0x400
l5557_sz=.-l5557
l5957: .space 0x400
ehci00_bss_sz=.-ehci00_bss_start
pci_slot: .word 0
std_dev_descriptor_t ehcidev_
