# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

   init_args
  arg_value o,"output file"
  lea ofn,%di
   call strcpy_
  ret
.data
ofn: .space 0x80
handle: .word 1
  arg_item x,hex_output,"hex output"
   init_args_term
  xcreate_file $ofn,$0
  mov %ax,handle

    fdprint handle," getting ext mem using 0x88 int 15\n"
  bios_ext_mem
  jnc 0f
  fdprint handle," cant get extended memory\n"
   jmp 1f
0:
  add $0x400,%ax
  push %ax
  push handle
    call outnumw
  fdprint handle,"k of physical memory\n"
1:
  fdprint handle,"using e801 from phoenix bios to get ext mem\n"
  bios_phoenix_ext_mem
   jnc 0f
  fdprint handle,"failed\n"
  jmp 1f
0:
  push %dx
   add $0x400,%ax
  push %ax
  push handle
  call outnumw
  fdprint handle, " mem between 1k and 16m in 1k blocks\n"
  mov %bx,%ax
  push %ax
  push handle
  call outnumw
  fdprint handle " mem above 16m 64k blocks\n"
  add $0x400,%cx
  mov %cx,%ax
  push %ax
  push handle
  call outnumw
   fdprint handle, " configured mem 1-16m in 1k blocks\n"
  pop %ax
  push %ax
  push handle
  call outnumw
   fdprint handle," configured mem above 16m 64k blocks\n"
  fdprint handle, "total="
  and $0xffff,%eax
  and $0xffff,%ecx
  shl $6,%eax
  add %ecx,%eax
  shl $10,%eax

  push %eax
  push handle
  call outnuml
 fdprint handle,"bytes\n"
1:
  dos_close_file handle
  terminate 00

outnumw: _enter
  if_z hex_output,0f,b
  fdhex 4(_bp),16,6(_bp)
  jmp 999f
0:   fdi2asc handle,w,6(_bp)
999:  leave
  ret $4

outnuml: _enter
  if_z hex_output,0f,b
  fdhex 4(_bp),32,6(_bp)
  jmp 999f
0:  fdi2asc handle,l,6(_bp)
999:  leave
  ret $6
