# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

minkeep=0x410

  jmp l54
.=0x18
stubinfo_memory_handle: .long 0
stubinfo_initial_size: .long 0
stubinfo_minkeep: .word 0x4000
stubinfo_ds_selector: .word 0
stubinfo_ds_segment: .word 0
stubinfo_psp_selector: .word 0
stubinfo_cs_selector: .word 0,0
stubinfo_basename: .word 0
.=0x44
l44:  .asciz "xdpmi.exe"
.=0x54
l54:
    xor %eax,%eax
  mov %cs,%ax
  mov %ax,%ds
  shl $4,%ax
   mov %eax,linear_start
   lea image_end,%bx
   shr $4,%bx
  inc %bx
  if %bx,a,$minkeep,0f
   mov $minkeep,%bx
0:
   dos_resize_memory
  jnc 0f
  puts "cant resize mem"
  terminate 01
0:
   mov $0x1687,%ax
  int $0x2f
  or %ax,%ax
  jnz 0f
   puts "Found dpmi server no need to reload"
  jmp 1f
0:
  call   do_exec
 mov    $0x1687,%ax
  int    $0x2f
  if_or %ax,%ax,z,1f
     puts "1687 failed"
  terminate 01
1:
  mov    %di,modesw
  mov    %es,modesw+2
  mov $6,%bx
  dos_allocate_memory
  jnc 0f
  puts "somethign failed"
  terminate 01
0:
  mov    %ax,%es
  mov    $0x1,%ax
  lcall  *modesw
  jnc 0f
   print_dollar "failed"
  terminate 99
0:
  cli
  mov %ds,%ax
  mov %ax,%es
  mov %ax,%fs
  mov %ax,%gs
  mov %ax,%ss
  sti
  dpmi_alloc_ldt $1
  jnc 0f
  terminate 01   
0:
  mov %ax,client_cs
  dpmi_alloc_ldt $1
  jnc 0f
  terminate 02
0:
  mov %ax,client_ds
  mov %ax,%bx
    mov linear_start+2,%cx
    mov linear_start,%dx
  dpmi_set_base_addr
  jnc 0f
     terminate 03
0:
  mov client_cs,%bx
    mov linear_start+2,%cx
    mov linear_start,%dx
  dpmi_set_base_addr
  jnc 0f
     terminate 04
0:
  mov client_cs,%bx
  mov %cs,%cx
  and    $0x3,%cx
  shl    $0x5,%cx
  or $0xc09b,%cx
  dpmi_set_access_rights 
  jnc 0f
  terminate 05
0:
  mov client_ds,%bx
  mov %cs,%cx
  and    $0x3,%cx
  shl    $0x5,%cx
  or $0xc093,%cx
  dpmi_set_access_rights 
  jnc 0f
  terminate 06
0:
   mov client_cs,%bx
   xor %cx,%cx
  mov $-1,%dx
   dpmi_set_seg_limit
  jnc 0f
  terminate 07
0: 
   mov client_ds,%bx
   xor %cx,%cx
  mov $-1,%dx
   dpmi_set_seg_limit
  jnc 0f
  terminate 08
0: 
  puts "we are going 32 bit"
   .byte 0xea
  .word 0f
client_cs:  .word 0
.code32
0:
  mov client_ds,%ax
   mov %ax,%ds
  print_dollar "bloody hell it worked"
   terminate 98
.code16
no_dpmi:
  puts "no dpmi server found"
  terminate 01
not_32_bit:
   puts "server is ok but not 32 bit"
  terminate 02

do_exec:
  push   %es
  push   %di
  push   %ds
  pop    %es
  mov    $load_pblock,%bx
  mov    %ds,0x4(%bx)
  mov %bx,0x2(%bx)
  mov    $l44,%dx
  mov    $0x4b00,%ax
  int    $0x21
  jnc 0f
  puts "exec failed"
  terminate 01
0:
  pop    %di
  pop    %es
  ret

.data
success: .asciz "ok we hit the 32 bt bit tie"
strlen_=.-success
dpmi_server: .asciz "xdpmi.exe"
load_pblock: .space 16,0
modesw: .long 0
client_ds: .word 0
linear_start: .long 0
