# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

 pci_bios_installation_check
  if_rz %ah,0f
  exit_msg $1,"no pci 2.0c bios installed"
0:

  fdprint $1,"scanning for open hci\n"
  playnote_ms $440,$500
   zeroreg %cx,%ax
0:
  push %ax
   call test_pci_dev
  jz 1f
   push %ax
  call print_dev_details
1:  inc %ax
  loop 0b
exit_prog: playnote_ms $1760,$500
  fdprint $1,"scan complete\n"
  terminate 00
test_pci_dev: enter $0,$0
   pusha
  mov 4(_bp),%bx
  zeroreg %di # get vendor
 pci_bios_cfg_word
   if_rz %cx,998f
   if %cx,e,$-1,998f
  mov %cx,vendor
  mov 4(_bp),%bx
  mov $0xa,%di # get class code
 pci_bios_cfg_word
    if %cx,ne,$0xc03,998f # usb code 
  mov 4(_bp),%bx
  mov $2,%di # get vendor
 pci_bios_cfg_word
  mov %cx,dev
  mov 4(_bp),%bx
  mov $0xe,%di # get header type
 pci_bios_cfg_char
   if_rnz %cl,998f # only other type
  mov 4(_bp),%bx
  mov $0x10,%di # get base address
 pci_bios_cfg_dword
  jnc 0f
  zeroreg %ecx
0:  mov %ecx,base_address_0
997: mov $1,%al # exit nz is success
  test $1,%al
  jmp 999f
998: # error exit ie. not found
   test $0,%al
999:  popa
  leave
  ret $sizeof_int
print_dev_details: enter $0,$0
   fdhex $1,16,%eax,$' '
    fdhex $1,16,vendor,$' '
    fdhex $1,16,dev,$' '
   exhibit $1,32,base_address_0
  leave
  ret $sizeof_int
.bss
vendor: .word 0
dev: .word 0
base_address_0: .long 0
