# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

  init_args
  arg_value s,"power state 1=standby 2=suspend 3=pwer off (default)"
   call strtoul_
  mov %ax,power_state
  ret
.data
power_state: .word 3
  init_args_term

# nicked this from grub ta to ggandalf and the geezers from grub
# never have worked this out in a zillion years without ther code...
	//sti		/* this is not needed here, so comment it out. */
	sti	#; added 2006-11-30

	/* detect APM */
	movw	$0x5300, %ax
	xorw	%bx, %bx
	int	$0x15
	jc	hard_stop
	/* don't check %bx for buggy BIOSes... */

	/* disconnect APM first */
	movw	$0x5304, %ax
	xorw	%bx, %bx
	int	$0x15

	/* connect APM */
	movw	$0x5301, %ax
	xorw	%bx, %bx
	int	$0x15
	//jc	EXT_C(hard_stop)
	jc	hard_stop

	/* set APM protocol level - 1.1 or bust. (this covers APM 1.2 also) */
	movw	$0x530E, %ax
	xorw	%bx, %bx
	movw	$0x0101, %cx
	int	$0x15
	//jc	EXT_C(hard_stop)
	jc	hard_stop

	/* set the power state to off */

 apm_power_state power_state
  playnote_ms $1760,$5000
 jmp hard_stop

	/* shouldn't reach here */
	//jmp	EXT_C(hard_stop)
	jmp	hard_stop
hard_stop:
	sti
	hlt
	jmp hard_stop
