%.bin32:%-elf32.o
	$(q)echo '_start = $(bin32_start);' >tmp
	$(q)$(elf32ld) tmp -T$(link_script) $< -o $@ $(linkmap_cmd) \
-L $(prod_libdir) -lasm32 -lasm16
%-elf.o:%.s
	$(q)$(call as_elf,.code16) -defsym real_mode=1
%-elf32.o:%.s
	$(q)$(as_elf) --defsym _d_lnx=1
%.exe:%.bin  $(prod_bindir)/addmzhdr.exe
	$(q)addmzhdr $< $(notdir $@) $(addmzhdr_opts)
%.com:%-elf.o $(prod_libdir)/libasm16.a
	$(q)$(call build_com,-o $@)
%.bin:%-elf.o $(prod_libdir)/libasm16.a
	$(q)$(bin_link)
%32.elf:%-elf32.o $(libdirs)/libasm32.a
	$(q)$(elf32ld) -Telf.ld $^ -o $@ 
$(prod_bindir)/%.exe:%.x $(prod_bindir)/stddll.dll
	$(q)$(x_link)
%.exe:%.8
	@rm -f $*.obj
	@a86 +o  $<  >'nul:'
	@if [ ! -f "$*.OBJ" ];then \
	  rename `strupr $<` $<; \
	  echo asm failed ;beep; \
	  exit 1; \
	fi
	@echo -e "\n$*.map\n" >z
	@86link $*.obj 'c:\mydocs\bin\lib86.obj' <z >86link.out; \
    if [ `fsize 86link.out`  $(dbgflags)t 2 ];then  \
      echo "link failed ($?)";rm $*.map  $@;beep; \
      exit 1; \
    fi
	@rename `strupr $@` $@
	@rm -f 86link.out
	$(q)$(cc) -c $(flite_preprocess) $< -o $@
%.lst:%.s
	$(q)as-lnx $(xtra) -I $(prod_incdir) $< -asml=$@
%-8.o:%.8
	$(q)a86 $< +o
	$(q)mv $*.OBJ $@
%.bt:%-elf.o
	$(q)$(elf32ld) -L $(prod_libdir) -T$(HOME)/src/boot.ld $< -lasm16 -o $@
%.obj:%.8
	$(q)cp $< tmp.8
	$(q)a86 +o tmp.8
	$(q)mv TMP.OBJ $@
%.elf32:%-elf32.o
	$(q)$(elf32ld) $^ -o $@
%.obj:%.asm
	$(q)masm $<,$@,q,q
