export HOME=.
export q=@
dbgflags=$(if $(dbg),-g)
export prod_bindir=$(HOME)/bin
export prod_libdir=$(HOME)/lib
prod_incdir=$(HOME)/include
export date=$(shell scripts/dt)
export time=$(shell scripts/tm)
ifdef linkmap
linkmap_cmd=-Map $*.map
endif
export asincdirs=$(incdirs)
export incdirflags=$(foreach d,$(incdirs),-I $(d))
gcc16=gcc-elf -c $(dir_var) $(incdirflags) $< -o $@ $(xtra)
elf32cc=gcc-elf32 -c $(1) \
-ffreestanding \
$(dir_var) \
$(xtra)  $($*_cc) \
-I . -I $(prod_incdir)   \
$< -o $@
include include/fl.mak
