ifeq (linux,$(TERM))
export gcc_libs=/usr/lib/gcc/i686-pc-linux/4.2.1-sjlj
libc=/usr/lib/libc.so
libm=/lib/libm.so.6
elf32ld=ld
elf32as=gas
lindir=$(HOME)/src/linux/2.$(1)
else
export gcc_libs=$(HOMEDRV)/bin/i586-linux/4.2.1-sjlj/lib
libc=$(HOMEDRV)/lib/gcc-lnx/libc.so
libm=$(HOMEDRV)/lib/gcc-lnx/libm.so.6
elf32as=as-lnx
elf32ld=ld-lnx
lindir=$(HOME)/src-gnu/linux/2.$(1)
endif
as_elf=echo '$1$(dir_as_echo)'|$(elf32as) $(dbgflags) - $(incdirflags) $($*_as) $(dir_as) $< -o $@
bin_start=0
bin32_start=0x100000
%.bin32:link_script=$(HOME)/src/bin.ld
%.bin:link_script=$(HOME)/src/bin.ld
%.com:link_script=$(HOME)/src/com.ld
# had --sort-ssection name in here chrisnose why forgot why i put it htere
build_com=$(elf32ld) -T$(link_script) $^ -L  $(prod_libdir) \
$($*_xtra) $($*_ld) -lasm16 \
$(xtra) \
$(1) \
$(linkmap_cmd)
define bin_link
	echo '_start = $(bin_start);'|cat - $(link_script) >tmp
	$(elf32ld) -m elf_i386 \
-T $(shell scripts/ifexists $*.ld tmp) \
--start-group $^ $($*_ld) --end-group \
-o $@  -L$(prod_libdir) \
$(linkmap_cmd)
endef

define as_elf_dt
	$(q)echo -e '$1.data\n comp_date_msg: .asciz "compiled on $(date)-$(time)"\n .text'|\
$(elf32as) - $(incdirflags) $< \
$($*_as) $(dir_as) \
   $(a_flags) $2 $3 $4 $5 $6 $7 $8
	$(q)mv a.out $@
endef
