# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"
# buils as a dos 16 bit .exe file
# uses same io irq etc as the device driver

_d_sample_rate=11025
_d_mad16_passwd_reg=0xf8f
.macro opti_passwd
  mov $0xe2,%ax
  mov    $_d_mad16_passwd_reg,%dx
  outb %al,(%dx)
.endm

.macro opti_outb n,p
  opti_passwd
  mov \n,%al
  mov \p,%dx
  out    %al,(%dx)
.endm
.struct 2*sizeof_int
mzt_sb_base: int_t 0
estruct
gsym mzt_init_sb _enter
  pusha
  opti_outb $0x40,$0xf8d
  opti_outb $0x10,$0xf91
  opti_outb $0,$0xf8d
  usleep $10
 opti_outb l16,$0xf8d
 sblast_reset mzt_sb_base(_bp)
  mov    $0x3,%bl
  opti_outb %bl,$0xf8e
  opti_passwd
 mov    $0xf8e,%dx
  in     (%dx),%al
  if %al,ne,%bl,0f
  call   l25d
  call   l77
  popa
0: leave
  ret $ret_sz
l77:
  opti_outb $0x10,$0xf91
0: _inb l30
  if %al,e,$0x80,0b
  _outb $0xa,l30
  _inb l30
  _outb l27,l32
  _inb l32
  _outb $0xb,l30
  _inb l30
  _outb l28,l32
  _inb l32
  mov l2d,%al
  xor    $0xf,%al
  shl    %al
  or     $0x1,%al
  mov    %al,l2d
  _outb $2,l30
  _inb l30
  _outb l2d,l32
  _inb l32
  _outb $3,l30
  _inb l30
  _outb l2d,l32
  _inb l32
  _outb $4,l30
  _inb l30
  _outb l2d,l32
  _inb l32
  _outb $5,l30
  _inb l30
  _outb l2d,l32
   _inb l32
  _outb $6,l30
  _inb l30
  _outb l2d,l32
  _inb l32
  _outb $7,l30
  _inb l30
  _outb l2d,l32
  _inb l32
  _outb $0,l30
  _inb l30
  _outb $0xa7,l32
  _inb l32
  _outb $1,l30
  _inb l30
  _outb $0xa7,l32
  _inb l32
0:  _inb l30
  if %al,e,$0x80,0b
  _outb $0x48,l30
  _outb l25,l32
0:  _inb l30
  if  %al,e,$0x80,0b

  _outb l1d,l30
  usleep $10
  opti_outb $0x20,$0xf91
  ret    
l25d: opti_outb l16,$0xf8d
 opti_outb l17,$0xf8e
  opti_outb l18, $_d_mad16_passwd_reg
  opti_outb l19,$0xf90
 opti_outb l1a,$0xf91
 opti_outb l1b,$0xf92
  opti_outb l1c,$0xf93
  ret
    .data
l16:.byte 1 # /m sets bit 2 dunno what this means midi? mixer?
l17:  .byte 0x13
l18: .byte 0x80
l19: .byte 0x2
l1a: .byte 0x10
l1b: .byte 0 
l1c: .byte 0
l1d:   .byte 0
l25: .byte 0xb
l27: .byte 2
l28:  .word 0x0000
l2a:  .byte 0
l2d:  .byte 7
l30: .word 0x0534
l32: .word 0x535
