# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

_d_sample_rate=11025

  call pinit
  if_z argc,0f,w
  mov argv,%si
  lea fn,%di
  call strcpy_
0:
  xopen_file $fn,$0
  mov %ax,handle
  dos_read handle,%ds,$l796,$max_audio_sz
  mov %ax,audio_len
   dos_close_file handle
call   driver_main
  terminate 00

driver_main:
  call   l762
  zeroreg %ax
  ret    
set_spkr_freq:
  pusha
  mov $0x34dd,%ax
  mov    $0x12,%dx
  div    %bx
  _outb $0xb6,$0x43
  out    %al,$0x42
  mov   %ah,%al
  out    %al,$0x42
  in $0x61,%al # switch speaker data
  and $0xfd,%al # but switch on timer - speaker gate enable
  or $1,%al
  out %al,$0x61
  popa
  ret    
reset_kbd:push   %ax
  in     $0x61,%al
  and    $0xfc,%al
  out    %al,$0x61
  pop    %ax
  ret    
sblast_write_audio:
  cld    
  mov audio_len,%cx
  mov    $l796,%si
0:  sblast_putc $0x10,sb_base
  lodsb
  sblast_putc %ax,sb_base
# wait a complete timer2 cycle
1:  in $0x61,%al
  if_unset $0x20,%al,1b
1:  in     $0x61,%al
  if_set $0x20,%al,1b
  loop   0b
  ret    
l762:
  pusha
  sblast_reset sb_base
  sblast_spkr sb_base,$1
  mov    $_d_sample_rate,%bx
  call   set_spkr_freq
  call   sblast_write_audio
  call   do_delay
  sblast_spkr sb_base,$0
  call   reset_kbd
  popa
  ret
do_delay:  usleep $10
 ret
fn: .asciz "c:\\mzttest.raw"
.=fn+256
sb_base:  .word 0x220
.bss
audio_len: .word 0
l796: .space 0x4000
max_audio_sz=.-audio_len
handle: .word 0
  .space 8192
stack_end: .word 0
