# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

.data
fn: .asciz "0x80-1"
boot_sect_fn: .asciz "bootfdos.bt"
dos_fat_fs_t i_
.bss
lfn: .space _d_max_path
.text
   mov %sp,%ax
    sub $image_end,%ax
     do_fd $1,"space avail=",i2asc,w,%ax,$'\n'
  push $fn
  push $i_fat_fs
  call fat_fs_init_io
   exit_if_cf $1,"open of fs failed"
   if_z i_dir_entries,0f,w
   mov $1,%eax
  jmp 1f
0:   movl i_root_cluster,%eax
1:
   push %ds
   push $cluster_buffer
   push %eax
    push $fat_process_slot
  push $i_fat_fs
  call fat_process_dir
exit_prog:  terminate 00

.struct 2*sizeof_int
slots: int_t 0
sec_buf_ix: int_t 0
estruct
fat_process_slot: _enter
  pusha
   fdhex $1,16,sec_buf_ix(_bp),$' '
   push slots(_bp)
   push $lfn
  call fat_dir_entry2name
   lea lfn,%si
   call dos_puts
     movw $0,pushax_ax(_bp)
  popa
  leave
   ret $ret_sz
.bss
cluster_buffer: .space 16*_d_sector_sz
