# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"
# regs apart from segs undefined on exit
# dl however is the boot disc
.ifndef _d_bochsout_com
_d_bochsout_com=1
.endif

.macro kill_bochs
  usleep $5
  double_fault
.endm

start_seg=0x60
    jmp 0f
start_sector: .long 2
boot_disc: .byte 0xff
uart: .word 0
0: mov %cs,%ax
  mov %ax,%ds
  mov $start_seg,%ax
  mov %ax,%es
   mov $0,%di
  mov $0x7c00,%si
  mov $0x100,%cx
  cld
  rep movsb
    ljmp $start_seg,$1f
1:  cli
 set_segs %cs
  lea -2,%sp
  sti
  mov %dl,boot_disc
  push %es
  zeroreg %di
  mov %di,%es
  get_drive_parameters
  pop %es
  and $0x3f,%cx
  inc %dh
  movzbw %dh,%di
   zeroreg %edx
  movzwl %cx,%esi
  mov start_sector,%eax
  div %esi
  mov %dx,%bx
  inc %bl
  zeroreg %dx
  div %di
 mov %ax,%cx
   xchg %ch,%cl
    shl $6,%cl
     or %bl,%cl
    mov %bl,%dh

  mov start_sector,%cx
  mov %ch,%dh

   mov $image_end,%ax
   shr $9,%ax
  inc %al
  mov boot_disc,%dl
  mov $code_start,%bx
   read_sector
  ljmp $start_seg,$code_start
fake_dos_hdlr:
  pusha
  if %ah,e,$2,0f
  if %ah,e,$6,0f
   jmp 1f
0: serial_putc %dx,uart
  jmp 999f
1: if %ah,ne,$0x40,999f
 if %bx,a,$2,999f
   serial_write uart,%dx,%cx
999:  popa
  iret
.=0x1fe
   .word 0xaa55
code_start:
  set_vector $_d_dos_vec,%cs,$fake_dos_hdlr
   port2uart $_d_bochsout_com
  mov %ax,uart
  serial_config uart,$0xc
user_code_start:
