# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "otrbios.h"

  mov %cs,%cs:orig_cs
 mov %cs,%eax
 shl $4,%eax
  movzwl l3e0a+2,%edx
   add %eax,%edx
  mov %edx,l3e0a+2

  mov $0x80,%dx
 mov %cs,%ax
   mov %ax,%ds
 mov %ax,%es
  jmp l7d4
l302:
  mov    0x2(%bx),%dh
  dec    %dh
  mov    %cx,0x10(%bp)
  call   l7a6
  je     l329
  mov    0x10,%dl
  and    $0xc0,%dl
  rol    $0x2,%dl
  inc    %dl
  movb   $0x10,0xc(%bp)
  mov    %gs,0x2(%bp)
  movw   $0x80d6,0x4(%bp)
  jmp    l32d
l329:mov    0x75,%dl
l32d:mov    %dx,0xe(%bp)
  xor    %ah,%ah
  ret    
l7d4:  shl    $0x10,%edx
  jmp    ladd
l7db:
# general config reg
  pci2isa_eio_read_byte $0xb0
  or     $0x1,%ah # select isa not eio
  pci2isa_eio_write_byte
 pci2isa_eio_read_byte $0x4e # external bus select 
  and    $0xfc,%ah # disabled access to kbd and rtc
   pci2isa_eio_write_byte
 pci2isa_eio_read_byte $0xcb # rtc cfg
  or     $0x5,%ah # forward accesses to 72/73 to upper 128 bytes of rtc+ normal 70/71
  pci2isa_eio_write_byte
  jmp    l811
l811:shr    $0x10,%edx # restore boot drive
  jmp    l2ed6
ladd:
  mov    %edx,%ecx # preserve edx
# red offset 0x4c of the northbridge
# which accordingot intels datasheet is somethign to do with th mtxc specific registers
# 40->4e
  mov    $0xcf8,%dx
  mov    $0x8000084c,%eax
  out    %eax,(%dx)
  out    %al,$0xed
  mov    $0xcfc,%dx
  in     (%dx),%eax
  and    $0xfffcffff,%eax
  out    %eax,(%dx)
# from ralph bornw this could be quantum scsi adaptor
  mov    $0x15c,%dx
  mov    $0x7,%al
  out    %al,(%dx)
  out    %al,$0xed
  mov    $0x0,%al
  inc    %dx
  out    %al,(%dx)
  out    %al,$0xed
  dec    %dx
  mov    $0x70,%al
  out    %al,(%dx)
  mov    $0x1,%al
  inc    %dx
  out    %al,(%dx)
  out    %al,$0xed
  dec    %dx
  mov    $0x71,%al
  out    %al,(%dx)
  out    %al,$0xed
  mov    $0x3,%al
  inc    %dx
  out    %al,(%dx)
  out    %al,$0xed
  dec    %dx
  mov    $0x30,%al
  out    %al,(%dx)
  out    %al,$0xed
  mov    $0x1,%al
  inc    %dx
  out    %al,(%dx)
  out    %al,$0xed
  dec    %dx
  mov    $0x7,%al
  out    %al,(%dx)
  out    %al,$0xed
  mov    $0x2,%al
  inc    %dx
  out    %al,(%dx)
  out    %al,$0xed
  dec    %dx
  mov    $0x30,%al
  out    %al,(%dx)
  out    %al,$0xed
  mov    $0x0,%al
  inc    %dx
  out    %al,(%dx)
  out    %al,$0xed
  mov    %ecx,%edx # restore ecx
  jmp    l7db
lebf:
  mov    $0xff,%al
  out    %al,$0xd
  out    %al,$0xed
  out    %al,$0xda
  out    %al,$0xed
  xor    %al,%al
  mov    $0x3d8,%dx
  out    %al,(%dx)
  out    %al,$0xed
  mov    $0x1,%al
  mov    $0x3b8,%dx
  out    %al,(%dx)
  out    %al,$0xed
  mov    $0x63,%dx
  di_call    l393e
  mov    $0x1,%al
  mov    $0x63,%dx
  di_call    l38c1
  mov    $0x66,%dx
  di_call    l393e
  mov    $0xfd,%al
  out    %al,$0x61
  out    %al,$0xed
  jmp    l2fc2

lf56:
  mov    %dx,%ax
  shl    $0x10,%eax
  cmos_foo   $0xde
  shr    $0x10,%eax
  mov    %ax,%dx
  smsw   %ax
  test   $0x1,%al# guess!
  je     lf93
  mov    %cs:0x3537,%ss
  mov    $0x400,%sp
  call   la04d
  mov    $300,%cx
lf80:loop   lf80
  xor    %al,%al
  cmos_foo    $0x84
  mov    $0xfe,%al
  out    %al,$0x64
lf91:
  print_msg "abandon hope"
  double_fault
lf93:jmp    l2fc2

lf96:
  mov    $0x7c0,%si
lf99:cmp    $0x7d4,%si
  je     lfb4
  mov    %cs:(%si),%bp
  testb  $0x80,%cs:0x3(%bp)
  je     lfaf
  di_call    l31fd
lfaf:add    $0x2,%si
  jmp    lf99
lfb4:jmp    l2fc2

lfb7:
  shl    $0x10,%ebx
  di_call    l3dac
  shr    $0x10,%ebx
  jmp    l2fc2

lfc8: .word l0302,l2fae,lf56
 .word l021c,l2fae,l3c96
 .word l0212,l2fae,l1354
 .word l0213,l2fae,l436b
 .word l0236,l2fae,l3cef
lfe6: .word l0324,l2fae,lfb7
 .word l0203,l2fae,l14f8
 .word l020a,l2fae,l134b
 .word l0104,l2fae,l1351
 .word l02ae,l2fae,l136a
 .word l0306,l2fae,lebf
 .word l0318,l2fae,l0e86
 .word l0308,l2fae,l1980
 .word l03c4,l2fae,l2fc2
 .word l0311,l2fae,lf96
 .word l030e,l2fae,l2fc2
 .word l030c,l2fae,l15e3
 .word l0116,l2fae,l0eff
 .word l0317,l2fae,l2fc2
 .word l0328,l2fae,l1983
 .word l033a,l2fae,l15e6
 .word l032a,l2fae,l0d8f
 .word l012c,l2fae,l0d23
 .word l012e,l2fae,l0dbf
 .word l032f,l2fae,l2fc2
 .word l0338,l2fae,l1986
 .word l8120,l2fae,lb3a8
 .word l8329,l2fae,l123c
 .word l8333,l2fae,l2422
 .word l83c1,l2fae,l9c5c
 .word l8309,l2fae,l0f44
 .word l010a,l2fae,l134b
 .word l030b,l2fae,l6e55
 .word l030f,l2fae,l7258
 .word l0310,l2fae,l2fc2
 .word l8114,l2fae,l1700
 .word l831a,l2fae,l1021
 .word l031c,l2fae,l3cac
 .word l8122,l2fae,l1726
 .word l8132,l2fae,lb408
 .word l8367,l2fae,l0085
 .word l0369,l2fae,l296b
 .word l836b,l2fae,l0085
 .word l033c,l2fae,l198c
 .word l033d,l2fae,l6e0e
 .word l8342,l08c9,l1e23
 .word l8146,l2fae,l1057
 .word l0345,l2fae,l2fc2
 .word l0349,l2fae,l75e6
 .word l8348,l2fae,l1080
 .word l034a,l2fae,l75f5
 .word l034c,l2fae,l1989
 .word l0324,l2fae,lfb7
 .word l8359,l2fae,l9c0c
 .word l8222,l2fae,l1819
 .word l8252,l2fae,l184c
 .word l8152,l2fae,l1763
 .word l8354,l2fae,l0085
 .word l8176,l2fae,l187d
 .word l8358,l2fae,l10be
 .word l834b,l2fae,l8f40
 .word l934e,l2fae,l1b96
 .word l8150,l2fae,l145b
 .word l8351,l2fae,l0085
 .word l835a,l2fae,l1b48
 .word l015b,l2fae,l6e58
 .word l815c,l2fae,l0ec7
 .word l8160,l2fae,l0d23
 .word l8162,l2fae,l0dda
 .word l1364,l2fae,lff57
 .word l0366,l2fae,l15ec
 .word l1368,l2fae,l15e9
 .word l816a,l2fae,l1aaf
 .word l816c,l2fae,l1c1e
 .word l816e,l2fae,l1c5c
 .word l8370,l2fae,l1acc
 .word l9372,l2fae,l1d65
 .word l837c,l2fae,l1e5b
 .word l937e,l2fae,l1458
 .word l1296,l2fae,l3f01
 .word l0380,l2fae,l2fc2
 .word l8388,l2fae,l1ea9
 .word l938a,l2fae,l1e01
 .word l0381,l2fae,l2fc2
 .word l0387,l2fae,lbc5a
 .word l0385,l2fae,l75eb
 .word l1382,l2fae,l7812
 .word l0384,l2fae,l7812
 .word l1386,l2fae,l7812
 .word l0383,l2fae,l7247
 .word l0389,l2fae,l6f25
 .word l938c,l2fae,l14e9
 .word l9390,l2fae,l2bfe
 .word l938b,l2fae,l0085
 .word l9395,l2fae,l9788
 .word l0392,l2fae,lff57
 .word l1398,l2fae,l75f0
 .word l0393,l2fae,l2fc2
 .word l039c,l0ac2,l296e
 .word l039d,l2fae,l2fc2
 .word l839e,l309a,l1d36
 .word l83a0,l2fae,l1d41
 .word l83a2,l2fae,l189e
 .word l83a4,l2fae,l0085
 .word l83c2,l2fae,l9d65
 .word l83c3,l2fae,l9da2
 .word l83a8,l2fae,l1b21
 .word l83aa,l2fae,l18f3
 .word l83ac,l2fae,l1f51
 .word l03ae,l2fae,l136a
 .word l93b0,l2fae,l1d8c
 .word l83b2,l2fae,l1d7a
 .word l93b4,l2fae,l1d82
 .word l83b5,l2fae,l8f9b
 .word l83be,l2fae,l1b12
 .word l83b6,l2fae,l0085
 .word l83bc,l2fae,l1d28
 .word l83ba,l2fae,l99fb
 .word l83bd,l2fae,l000a
 .word l83bf,l2fae,l1e97
 .word l038f,l2fae,l7229
 .word l0391,l2fae,l7271
 .word l039f,l2fae,l723c
 .word l0397,l2fae,l2fc2
 .word l8399,l2fae,l0085

l1354:
  jmp    l3e18

l2ed6:  jmp    l2ed9
l2ed9:jmp    l2edc
l2edc:jmp    l2edf
l2edf:
mov    $0xbf,%al
  out    %al,$0x70
  in     $0x64,%al # rad kbd status
  out    %al,$0xed
  test   $0x4,%al # system status 0 is power up or reset, 1 is post ok (from r brown)
  jmp l2efe # pretend we are a power up
  je     l2efe
  mov    $0x1,%al
  cmos_foo   $0xe1
  jmp    l2ef9
l2ef9:
# set up addr for  indirect call is offset 4 from here
mov    $lfc8,%bx # gets used at sart of 2f5e
  jmp    l2f40
l2f01:
  mov    $0x0,%ax
  jmp    l2f23

l2f06:
  mov    $0x84,%dx
  di_call    l3956
  cmp    $0x2,%ax
  je     l2f23
  mov    %ax,%si
  xor    %ax,%ax
  mov    $0x84,%dx
  di_call    l38d9
  mov    %si,%ax
l2f23:# al is zeero first time thru
  xor    %ah,%ah
  if %al,b,$0xb,l2f2b
  xor    %al,%al
l2f2b:
shl    %ax
  add    $l3d31,%ax
  mov    %ax,%si 
  mov    %cs:(%si),%bx# get fc8
  xor    %al,%al
  cmos_foo   $0xe1
  mov    %cs:l3535,%ds
  mov    $0x0,%ax
  mov    %ax,%ss
  mov    %ax,%es
  mov    $0x7c00,%esp
  mov    $0xf000,%ax
  mov    %ax,%gs
  rol    $0x10,%edx
  jmp    l302c

l2efe:jmp    l2fcd # power upor reset

l2f40:
  mov    %cs:l3535,%ds
  mov    $0x0,%ax
  mov    %ax,%ss
  mov    %ax,%es
  mov    $0x7c00,%esp
  mov    $0xf000,%ax
  mov    %ax,%gs
  rol    $0x10,%edx
  jmp    l302c

l2f5e:# bx is somewhre in teh lfc8 lookup table
  if %bx,ae ,$lfe6,l2f6f
  mov    $0xe1,%dx
  di_call    l3956
  jmp    l2f78
l2f6f:
  mov    $0xe1,%dx
  di_call   l393e
l2f78:
  ror    $0x10,%edx
  inc    %al
  and    %cs:0x1(%bx),%al
  je     l2fc7
  mov    $l2fc2,%di
  mov    %cs:(%bx),%ax
  inc    %bx
  inc    %bx
  mov    %ax,%cx
  or     %al,%al
  je     l2fa1
  mov    %dx,%cx
  mov    %cs:l66ce,%dx
  out    %al,(%dx)
  mov    %cx,%dx
  mov    %ax,%cx
  jmp    l2fa1
l2fa1:jmp    l2fa4
l2fa4:jmp    l2fa7
l2fa7:mov    %cs:(%bx),%ax
  inc    %bx
  inc    %bx
  jmp    *%ax
l2fae:  mov    %cs:(%bx),%si
  mov    %cs:-0x4(%bx),%cx
  test   $0x8000,%cx
  jne    l2fbd
  jmp    *%si
l2fbd:ljmp   $0xe2e9,$0x83
  inc    %bx
  inc    %bx
  jmp    l2f40
l2fc2:
  inc    %bx
  inc    %bx
  jmp    l2f40
l2fc7:add    $0x6,%bx
  jmp    l2f40

l2fcd:
# get rid
  pci_pm_read_byte $0x8
  cmp    $0x1,%ah
  mov    $0x20,%al
  jb     l2fde
  mov    $0x40,%al
l2fde:
# we shuld have al=0x40 by here for rid=1
mov    $0x8000,%cx
  mov    %cl,%ah
# write $0x8000 into either $0x20/0x21 or $0x40/41
  bx_call l53a8
  inc    %al
  mov    %ch,%ah
  bx_call   l53a8
  pci_pm_read_byte $0x80 # misc pm functions!
  or     $0x1,%ah # god knows
  bx_call    l53a8
  pci2isa_eio_read_byte $4 # get pcicmd
  or     $0x8,%ah
 pci2isa_eio_write_byte
# dx still has teh long suffering boot drive!
# cx is still 8000 from above
  mov    %dx,%si
  mov    %cx,%dx
  add    $0x1,%dx
  mov    $0x1,%al
  out    %al,(%dx) # out $1,$0x8000 godknows!
  mov    %cx,%dx
  add    $0x5,%dx
  mov    $0x14,%al
  out    %al,(%dx) # out $0x14,$0x8005
  mov    %si,%dx # restore boot drive
  jmp    l2f01

 otrbios_exit $1,"ok here"

l302c:  mov    %bx,%cx# i thik this is ttehe lfc8 look up
  mov    $0x1,%al
  bx_call l541e # get  port 8000+1
  test   $0x1,%ah # his returns 0x0
  mov    %cx,%bx
  je     l307f
  xor    %ax,%ax
  mov    $0xb4,%dx
  di_call   l38c1
  mov    $0x1,%al
  mov    $0x1,%ah
  bx_call l54b1
  mov    $0x2b,%al
  bx_call l541e
  or     $0x1,%ah
  bx_call l54b1
  mov    $0x5,%al
  bx_call l541e
  and    $0xc3,%ah
  bx_call l54b1
  or     $0x20,%ah
  bx_call l54b1
l307d:otrbios_exit $1,"l307d abandon hope"
l307f:
  jmp l2f5e

l3527: ret
l3533: jmp *%di

l3535: .word 0x40
l36d2:
 .byte 0x01,0x03,0x07,0x0f,0x1f,0x3f,0x7f,0xff,0x66,0x50,0x66,0x53,0x51,0x66,0x52,0xe8
 .byte 0x63,0x01,0x92,0x66,0xd3,0xe2,0x66,0x23,0xd3,0x8a,0xe0,0xe8,0xf0,0xfe,0xf6,0xd3
 .byte 0x22,0xc3,0x0a,0xc2,0xe8,0xfe,0xfe,0xfe,0xc4,0x66,0xc1,0xea,0x08,0x66,0xc1,0xeb
 .byte 0x08,0x75,0xe8,0x66,0x5a,0x59,0x66,0x5b,0x66,0x58,0xc3
l370d:
  mov    %al,%ah
  mov    %dh,%al
  shr    $0x4,%al
  mov    $l36d2,%bx
  xlat   %cs:(%bx)
  xchg   %ah,%al
  mov    %cx,%bx
  mov    %dl,%cl
  and    $0x7,%cl
  shr    $0x3,%dx
  mov    %dl,%ch
  mov    %al,%dl
  mov    %ch,%al
  or     %cs:l3f07,%al
  out    %al,$0x70
  out    %al,$0xed
  in     $0x71,%al
  out    %al,$0xed
  ror    %cl,%al
  and    %ah,%dl
  not    %ah
  and    %ah,%al
  or     %dl,%al
  rol    %cl,%al
  mov    %al,%ah
  mov    %ch,%al
  or     %cs:l3f07,%al
  out    %al,$0x70
  out    %al,$0xed
  mov    %ah,%al
  out    %al,$0x71
  out    %al,$0xed
  jmp    *%di
l3759: otrbios_exit $1,"l3759"

l3792:mov    %dh,%al
  shr    $0x4,%al
  mov    $l36d2,%bx
  xlat   %cs:(%bx)
  xchg   %ah,%al
  mov    %cx,%bx
  mov    %dl,%cl
  and    $0x7,%cl
  shr    $0x3,%dx
  mov    %dl,%al
  or     %cs:0x3f07,%al
  out    %al,$0x70
  out    %al,$0xed
  in     $0x71,%al
  out    %al,$0xed
  ror    %cl,%al
  and    %ah,%al
  mov    $0x0,%ah
  jmp    *%di

l3807:
 .word l370d,l3533,l3533,l3533,l3533,l3533,l3533,l3533
 .word l3759,l3527,l3527,l3527,l3a12,l3a12,l3a12,l3a12
l3827: .word l3792,l3533,l3533,l3533,l3533,l3533,l3533,l3533
l38c1:
  mov    %bx,%cx
  mov    %dx,%bx
  mov    %cs:l69e3(%bx),%dx
  mov    %cs:l69e2(%bx),%bl
  and    $0x7,%bx
  shl    %bx
  jmp    *%cs:l3807(%bx)

l38d9:
  mov    %bx,%cx
  mov    %dx,%bx
  mov    %cs:l69e3(%bx),%dx
  or     $0x400,%dx
  jmp    l370d

l393e:
  mov    %bx,%cx
  mov    %dx,%bx
  mov    %cs:l69e3(%bx),%dx
  mov    %cs:l69e2(%bx),%bl
  and    $0x7,%bx
  shl    %bx
  jmp    *%cs:l3827(%bx)

l3956:
  mov    %bx,%cx
  mov    %dx,%bx
  mov    %cs:l69e3(%bx),%dx
  or     $0x400,%dx
  jmp    l3792

l3a12: otrbios_exit $1,"l3a12"

l3c96:
  mov    $0x84,%dx
  di_call    l3956
l3c9f:  cmp    $0x7,%al
  jb     l3ca7
  cmp    $0xb,%al
  jb     l3ca9
l3ca7:jmp    l3cac
l3ca9:jmp    l2fc2
l3cac:mov    $0x11,%al
  out    %al,$0x20
  out    %al,$0xed
  mov    $0x21,%dx
  mov    $0x8,%al
  out    %al,(%dx)
  out    %al,$0xed
  mov    $0x4,%al
  out    %al,(%dx)
  out    %al,$0xed
  mov    $0x1,%al
  out    %al,(%dx)
  out    %al,$0xed
  mov    $0xff,%al
  out    %al,(%dx)
  out    %al,$0xed
  mov    $0x11,%al
  out    %al,$0xa0
  out    %al,$0xed
  mov    $0xa1,%dx
  mov    $0x70,%al
  out    %al,(%dx)
  out    %al,$0xed
  mov    $0x2,%al
  out    %al,(%dx)
  out    %al,$0xed
  mov    $0x1,%al
  out    %al,(%dx)
  out    %al,$0xed
  mov    $0xff,%al
  out    %al,(%dx)
  out    %al,$0xed
  mov    $0x0,%al
  out    %al,$0xf1
  out    %al,$0xed
  jmp    l2fc2
l3cef:
  mov    $0x84,%dx
  di_call    l3956
l3cf8:  jne    l3d2e
  call   l3527
  call   la04d
  mov    $0xdf,%al
  jae    l3d09
# this is an ljmp in the bios proper
  jmp l13b6
l3d09:
# i assume ds must be 0x40 adn this is obviulsy testing for a warm reboot
cmpw   $0x1234,0x72
  jne    l3d2e
  xor    %ax,%ax
  push   %dx
  mov    $0xde,%dx
  call   l388d
  pop    %dx
  testw  $0x100,%cs:l66a8
  je     l2fc2
# frig same result as bios
  mov %cs,%cs:l0f+3
l0f: lcall  $0xf000,$l1357
  jmp    l2fc2
l3d2e:jmp    l2f06

# Iam pretty certain we die adeathhere god knwos wha its doint cant fathomit
l3e18:
  shl    $0x10,%edi
  mov    $0xc0,%dx
  di_call   l3956
  mov    %ax,%si
  shl    $0x1d,%esi
  wbinvd  # nope havent the foggiest!
  nop    
  nop    
  nop    
  mov    %cr0,%eax
  and    $0x9fffffff,%eax
  or     %esi,%eax
  mov    %eax,%cr0
  wbinvd 
  nop    
  nop    
  nop    
  shr    $0x10,%edi
  jmp    l2fc2
l3d31: .word lfc8,lfc8

l3dbe:
  mov %cs,%cs:l3dbe_0f
  cli    
  cld    
  mov    $l3e0a,%si
  lgdtw  %cs:(%si)
  mov    %cr0,%eax
  or     $0x1,%al
  mov    %eax,%cr0
  jmp    0f
0:mov    %bx,%ds
  mov    %bx,%es
  mov    %bx,%fs
  mov    %bx,%gs
  mov    %cr0,%eax
  and    $0xfe,%al
  mov    %eax,%cr0
l3dbe_0f:  ljmp   $0xf000,$1f
1:  xor    %ax,%ax
  mov    %ax,%ds
  mov    %ax,%es
  mov    %ax,%fs
  mov    %ax,%gs
  jmp    *%di

#gdt is here, it idoesnt look valid but is hats in teh bios
l3df2:
 .word gdtl,l3df2,0x930f,0x0000
 .word 0xffff,0x0000,0x9300,0x008f
 .word 0xffff,0x0000,0x9300,0x0000
gdtl=.-l3df2
l3e0a: .word gdtl-1,l3df2,0
l3f07: .byte 0
l4280:
  jmp    l4297
l4286: jmp l42f4
l4297:mov    %dx,%di
  shl    $0x10,%edi
  ror    $0x10,%eax # prserv ax
  mov    %ax,%di
  rol    $0x10,%eax
  mov    %ax,%si # get entry parm
  xor    %ah,%ah
  ror    $0xb,%eax
  mov    %cs:l6606,%al
  ror    $0x5,%eax
  mov    $0x8000,%ax
  ror    $0x10,%eax
  and    $0xfc,%al
  mov    $0xcf8,%dx
  out    %eax,(%dx)
  mov    %si,%ax
  mov    $0xcfc,%dx
  and    $0x3,%si
  add    %si,%dx
  xchg   %al,%ah
  in     (%dx),%al
  xchg   %al,%ah
  ror    $0x10,%eax # result is now topof 32 bits
  mov    %di,%ax
  rol    $0x10,%eax # restore it to ah
  shr    $0x10,%edi
  mov    %di,%dx
  jmp    *%bx
l42f4:
  mov    %dx,%di
  shl    $0x10,%edi
  ror    $0x10,%eax
  mov    %ax,%di
  rol    $0x10,%eax
  mov    %ax,%si
  xor    %ah,%ah
  ror    $0xb,%eax
  mov    %cs:l6606,%al
  ror    $0x5,%eax
  mov    $0x8000,%ax
  ror    $0x10,%eax
  and    $0xfc,%al
  mov    $0xcf8,%dx
  out    %eax,(%dx)
  mov    %si,%ax
  mov    $0xcfc,%dx
  and    $0x3,%si
  add    %si,%dx
  xchg   %al,%ah
  out    %al,(%dx)
  xchg   %al,%ah
  ror    $0x10,%eax
  mov    %di,%ax
  rol    $0x10,%eax
  shr    $0x10,%edi
 mov %di,%dx
   jmp    *%bx
l436b:
  shl    $0x10,%ebx
  mov    $0x84,%dx
  di_call   l3956
  cmp    $0x1,%ax
  ja     l4380
  call   laaa3
l4380:shr    $0x10,%ebx
  jmp    l2fc2

l438b:
  push   %esi
  lea lda17-ld7d0,%esi
  call   l5dfa
  mov    %cs:(%si),%al
  pop    %esi
  ret    

l5375:  mov    %eax,%edi
  mov    %dx,%si
  mov    %cs:l6606,%ah
  shl    $0x3,%ah
  or     $0x3,%ah
  ror    $0x10,%eax
  mov    $0x8000,%ax
  rol    $0x10,%eax
  and    $0xfc,%al
  mov    $0xcf8,%dx
  out    %eax,(%dx)
  mov    %edi,%eax
  mov    %al,%dl
  or     $0xfc,%dl
  xchg   %al,%ah
  in     (%dx),%al
  xchg   %al,%ah
  mov    %si,%dx
  jmp    *%bx

l53a8:
  mov    %eax,%edi
  mov    %dx,%si
  mov    %cs:l6606,%ah
  shl    $0x3,%ah
  or     $0x3,%ah
  ror    $0x10,%eax
  mov    $0x8000,%ax
  rol    $0x10,%eax
  and    $0xfc,%al
  mov    $0xcf8,%dx
  out    %eax,(%dx)
  mov    %edi,%eax
  mov    %al,%dl
  or     $0xfc,%dl
  xchg   %al,%ah
  out    %al,(%dx)
  xchg   %al,%ah
  mov    %si,%dx
  jmp    *%bx
# complicated way of getting port 8000+entry param
l541e:mov    %eax,%edi
  mov    %dx,%si
  mov    $0x8000,%ax
  shl    $0x10,%eax
  mov    %cs:l6606,%ah
  shl    $0x3,%ah
  or     $0x3,%ah
  mov    $0x8,%al
  mov    $0xcf8,%dx
  out    %eax,(%dx)
  mov    $0xcfc,%dx
  in     (%dx),%al
  cmp    $0x1,%al
  mov    $0x20,%al
  jb     l5448
  mov    $0x40,%al
l5448:mov    $0xcf8,%dx
  out    %eax,(%dx)# get b40
  mov    %di,%dx
  mov    %al,%dh
  mov    %dx,%di # di is 20/40+entry param 
  mov    $0xcfc,%dx
  in     (%dx),%ax# get b40
  and    $0xfffffffc,%ax# turns 8001 into 8000
  cmp    $0x0,%ax
  jne    l5463
  mov    $0x8000,%ax
  out    %ax,(%dx)
l5463:mov    $0x8000,%ax
  shl    $0x10,%eax
  mov    %cs:l6606,%ah
  shl    $0x3,%ah
  or     $0x3,%ah
  mov    $0x4,%al# ax= b04
  cmp    $0x2100,%di#  is 4000 for rid=1
  jb     l547f
  mov    $0x80,%al
l547f:mov    $0xcf8,%dx
  out    %eax,(%dx)# get b80 (misc pm!)
  mov    $0xcfc,%dx
  in     (%dx),%al
  or     $0x1,%al
  out    %al,(%dx) # and replace it
  mov    %di,%dx
  mov    %dh,%al# get 20/40 depending on rid
  mov    $0xcf8,%dx
  out    %eax,(%dx)
  mov    $0xcfc,%dx
  in     (%dx),%ax # get b40 (8001)
  and    $0xfffffffc,%ax
  mov    %ax,%dx # dx=8000
  mov    %di,%ax
  xor    %ah,%ah
  add    %ax,%dx# 8000+entry param
  mov    %al,%ah # preeeserve entry param
  in     (%dx),%al# get port 8000 (11)
  xchg   %ah,%al
  mov    %ax,%di # = 8000 contents (11)+param
  mov    %edi,%eax
  mov    %si,%dx
  jmp    *%bx
l54b1:mov    %eax,%edi
  mov    %dx,%si
  mov    $0x8000,%ax
  shl    $0x10,%eax
  mov    %cs:l6606,%ah
  shl    $0x3,%ah
  or     $0x3,%ah
  mov    $0x8,%al
  mov    $0xcf8,%dx
  out    %eax,(%dx)
  mov    $0xcfc,%dx
  in     (%dx),%al
  cmp    $0x1,%al
  mov    $0x20,%al
  jb     l54db
  mov    $0x40,%al
l54db:mov    $0xcf8,%dx
  out    %eax,(%dx)
  mov    $0xcfc,%dx
  in     (%dx),%ax
  and    $0xfffffffc,%ax
  cmp    $0x0,%ax
  jne    l54f0
  mov    $0x8000,%ax
  out    %ax,(%dx)
l54f0:mov    $0x8000,%ax
  shl    $0x10,%eax
  mov    %cs:l6606,%ah
  shl    $0x3,%ah
  or     $0x3,%ah
  mov    $0x8,%al
  mov    $0xcf8,%dx
  out    %eax,(%dx)
  mov    $0xcfc,%dx
  in     (%dx),%al
  cmp    $0x1,%al
  mov    $0x4,%al
  jb     l5515
  mov    $0x80,%al
l5515:mov    $0xcf8,%dx
  out    %eax,(%dx)
  mov    $0xcfc,%dx
  in     (%dx),%al
  or     $0x1,%al
  out    %al,(%dx)
  mov    $0x8000,%ax
  shl    $0x10,%eax
  mov    %cs:l6606,%ah
  shl    $0x3,%ah
  or     $0x3,%ah
  mov    $0x8,%al
  mov    $0xcf8,%dx
  out    %eax,(%dx)
  mov    $0xcfc,%dx
  in     (%dx),%al
  cmp    $0x1,%al
  mov    $0x20,%al
  jb     l5546
  mov    $0x40,%al
l5546:mov    $0xcf8,%dx
  out    %eax,(%dx)
  mov    $0xcfc,%dx
  in     (%dx),%ax
  and    $0xfffffffc,%ax
  mov    %ax,%dx
  mov    %di,%ax
  xor    %ah,%ah
  add    %ax,%dx
  mov    %di,%ax
  xchg   %ah,%al
  out    %al,(%dx)
  xchg   %ah,%al
  mov    %edi,%eax
  mov    %si,%dx
  jmp    *%bx

l5dfa:
  push   %ax
  mov    $ld7d0,%ax
  add    %ax,%si
  pop    %ax
  ret    

l6606: .byte 1
l665d: .word 2
l66a8: .word 0x185
l66ce: .word 0x80
l69e2: .byte 0
l69e3:
  .byte 0xae,0x01,0x00,0xaf,0x01,0x10,0xd8,0x70,0x10,0xd8,0x00,0x10,0xd9,0x00,0x10,0xda
  .byte 0x00,0x10,0xdb,0x00,0x10,0xdc,0x00,0x10,0xdd,0x20,0x10,0xe0,0x70,0x10,0xe0,0x00
  .byte 0x10,0xe1,0x00,0x10,0xe2,0x00,0x10,0xe3,0x00,0x10,0xe4,0x00,0x10,0xe5,0x20,0x10
  .byte 0xe8,0x70,0x10,0xe8,0x00,0x10,0xe9,0x00,0x10,0xea,0x00,0x10,0xeb,0x00,0x10,0xec
  .byte 0x00,0x10,0xed,0x20,0x10,0xf0,0x70,0x10,0xf0,0x00,0x10,0xf1,0x00,0x10,0xf2,0x00
  .byte 0x10,0xf3,0x00,0x10,0xf4,0x00,0x10,0xf5,0x20,0x08,0x00,0x90,0x00,0x50,0x70,0x00
  .byte 0x58,0x00,0x00,0x59,0x60,0x00,0x60,0x70,0x00,0x68,0x60,0x00,0x6f,0x00,0x00,0x70
  .byte 0x10,0x00,0x72,0x00,0x00,0x73,0x00,0x00,0x74,0x00,0x00,0x75,0x00,0x00,0x76,0x00
  .byte 0x00,0x77,0x00,0x00,0x78,0x70,0x10,0x80,0x70,0x10,0x80,0x30,0x10,0x84,0x30,0x10
  .byte 0x90,0x30,0x10,0x94,0x30,0x10,0x98,0x00,0x10,0xa0,0x70,0x10,0xa8,0xf0,0x10,0xb8
  .byte 0xf0,0x10,0xc8,0x70,0x10,0xd0,0x70,0x20,0x70,0x71,0x20,0x78,0x71,0x00,0x80,0xf1
  .byte 0x00,0x90,0x71,0x00,0x98,0x01,0x00,0x99,0x01,0x00,0x9a,0x01,0x00,0x9b,0x01,0x00
  .byte 0x9c,0x11,0x00,0x9c,0x01,0x00,0x9d,0x01,0x00,0x9e,0x01,0x00,0x9f,0x01,0x00,0xa0
  .byte 0x71,0x00,0xa0,0x51,0x00,0xa6,0x11,0x00,0xa8,0x01,0x10,0x89,0x30,0x00,0xa9,0x01
  .byte 0x00,0xaa,0x01,0x00,0xf8,0xf1,0x00,0x08,0x72,0x10,0x8d,0x00,0x10,0x8e,0x00,0x20
  .byte 0x10,0xf2,0x10,0x88,0x00,0x10,0x99,0x10,0x10,0x99,0x00,0x10,0x9a,0x00,0x10,0x8f
l7dd1:call   l3527
  push   %eax
  push   %edx
  push   %esi
  si_call    l7de6
  pop    %esi
  pop    %edx
  pop    %eax
  ret    
l7de6:rol    $0x10,%eax
  rol    $0x10,%esi
  shr    $0x2,%cx
  cmp    $0x2,%cx
  jae    l7e01
  mov    $0x2,%cx
  jmp    l7e01
l7dfb:
  si_call    l9295
l7e01:  in     (%dx),%al
  and    %bh,%al
  cmp    %bl,%al
  je     l7e0a
  loop   l7dfb
l7e0a:rol    $0x2,%cx
  ror    $0x10,%eax
  ror    $0x10,%esi
  jmp    *%si
l7e17:push   %ax
  push   %ecx
  movzwl %cx,%ecx
  shl    %ecx
  jmp    l7e2b
l7e23:push   %cx
  mov    $0x1,%cx
  call   l92a1
  pop    %cx
l7e2b:in     (%dx),%al
  and    %bh,%al
  cmp    %bl,%al
  je     l7e35
  loopl  l7e23
l7e35:pop    %ecx
  pop    %ax
  ret    

l9295:
push   %dx
  push   %cx
  mov    $0x8,%cx
  call   l92a1
  pop    %cx
  pop    %dx
  jmp    *%si
l92a1:mov    $0xef,%ah
  add    $0x2,%cx
l92a6:out    %al,$0xed
  in     $0x61,%al
  and    $0x10,%al
  cmp    %ah,%al
  je     l92a6
  mov    %al,%ah
  loop   l92a6
  ret    
l92b5:call   l3527
  push   %ax
  push   %cx
  in     $0x61,%al
  mov    %al,%ah
l92be:mov    (%si),%al
  and    %bh,%al
  cmp    %bl,%al
  je     l92d6
  in     $0x61,%al
  and    $0x1010,%ax
  cmp    %ah,%al
  je     l92be
  xor    $0x10,%ah
  je     l92be
  loop   l92be
l92d6:pop    %cx
  pop    %ax
  ret    
l92d9:push   %bx
  mov    $0x8,%bx
  call   l92f3
  pop    %bx
  ret    
  call   l92d9
  lret   
l92e6:push   %bx
  mov    $0x10,%bx
  call   l92f3
  pop    %bx
  ret    
  call   l92e6
  lret   
l92f3:pushf  
  push   %fs
  push   %gs
  push   %eax
  push   %si
  push   %di
  di_call    l3dbe
  print_msg "back from protected flip"


la04d:call   l3527
  mov    $0xd1df,%ax
  testb  $0x2,%cs:l665d
  je     la05d
  mov    $0x5f,%al
la05d:call   la096
  jne    la074
  mov    $0xff,%al
  out    %al,$0x64
  push   %cx
  mov    $0xffff,%cx
la06a:in     $0x64,%al
  test   $0x2,%al
  loopne la06a
  pop    %cx
  clc    
  je     la075
la074:stc    
la075:ret    
la076:call   l3527
  mov    $0xd1dd,%ax
  testb  $0x2,%cs:l665d
  je     la086
  mov    $0x5d,%al
la086:call   la096
  clc    
  je     la08d
  stc    
la08d:ret    

la08e:
  call   la04d
  lret   
la092:  call   la076
  lret   
la096:
call   la0ae
  jne    la0a0
  out    %al,$0x60
  call   la0bd
la0a0:ret    

la0ae:
  call   la0d0
  jne    la0bc
  xchg   %al,%ah
  out    %al,$0x64
  xchg   %al,%ah
  call   la0bd
la0bc:ret    
la0bd:push   %bx
  push   %cx
  push   %dx
  mov    $0x64,%dx
  mov    $0x200,%bx
  mov    $0x8235,%cx
  call   l7dd1
  pop    %dx
  pop    %cx
  pop    %bx
  ret    
la0d0:push   %eax
  push   %ebx
  push   %ecx
  push   %edx
  push   %esi
  push   %esp
  push   %di
  mov    $0x1388,%cx
la0e0:shl    $0x10,%ecx
  mov    $0x64,%dx
  mov    $0x300,%bx
  mov    $0x1,%cx
  call   l7dd1
  je     la102
  in     $0x64,%al
  test   $0x1,%al
  je     la0fa
  in     $0x60,%al
la0fa:shr    $0x10,%ecx
  loop   la0e0
  or     $0xff,%al
la102:pop    %di
  pop    %esp
  pop    %esi
  pop    %edx
  pop    %ecx
  pop    %ebx
  pop    %eax
  ret    



laaa3:
  call   l3527
  mov    $0xffff,%si
laaa9:call   lad84
  jb     laaf6
  mov    $0x10a,%dx
  call   ld3ed
  or     %ax,%ax
  je     laaf1
  cmp    $0x6,%ah
  jne    laac3
  cmp    $0x4,%al
  je     laad3
  jb     laaf1
laac3:mov    $0x104,%dx
  call   ld3ed
  and    $0xfffffffb,%ax
  mov    $0x4,%dh
  call   ld3ed
  jmp    laaf1
laad3:or     %bh,%bh
  jne    laaf1
  mov    $0x40,%ax
  mov    $0x33e,%dx
  call   ld3ed
  mov    $0x1,%al
  call   lf7b1
  mov    %cs:0x68b9,%al
  call   ld3ed
  mov    $0x80,%al
  call   lf7b1
laaf1:mov    $0x0,%si
  jmp    laaa9
laaf6:ret

lad84:
  push   %ax
  push   %cx
  push   %dx
  pushf  
  call   l438b
  mov    %al,%ch
  mov    $0xff,%cl
  cmp    $0xffffffff,%si
  jne    lad99
  mov    $0x0,%bx
  jmp    lad9e
lad99: 
call   ladb4
  jb     ladae
lad9e:mov    $0x0,%dl
  mov    $0x1,%dh
  call   ld3ed
  cmp    $0xffffffff,%ax
  je     lad99
  popf   
  clc    
  jmp    ladb0
ladae:popf   
  stc    
ladb0:pop    %dx
  pop    %cx
  pop    %ax
  ret    
ladb4:push   %ax
  push   %dx
  push   %si
  cmp    %cx,%bx
  jae    lade4
  mov    %bx,%si
  and    $0x7,%si
  jne    laddc
  mov    $0x0,%dl
  mov    $0x1,%dh
  call   ld3ed
  cmp    $0xffffffff,%ax
  je     ladd9
  mov    $0xe,%dl
  mov    $0x0,%dh
  call   ld3ed
  test   $0x80,%al
  jne    laddc
ladd9:or     $0x7,%bx
laddc:cmp    %cx,%bx
  jae    lade4
  inc    %bx
  clc    
  jmp    lade7
lade4:stc    
  jmp    lade7
lade7:pop    %si
  pop    %dx
  pop    %ax
  ret 
ld379:
ld379:xchg   %eax,%ebx
  ror    $0x8,%eax
  mov    $0x80,%ah
  rol    $0x10,%eax
  mov    %dl,%al
  and    $0xfc,%al
  shld   $0x10,%edx,%ecx
  shl    $0x10,%edx
  cli    
  mov    $0xcf8,%dx
  out    %eax,(%dx)
  shl    $0x8,%eax
  shr    $0x10,%edx
  mov    %dx,%ax
  shl    $0x10,%edx
  mov    $0xcfc,%dx
  and    $0x3,%al
  add    %al,%dl
  shr    $0x8,%ax
  xchg   %eax,%ebx
  cmp    $0x0,%bl
  je     ld3cd
  cmp    $0x1,%bl
  je     ld3d0
  cmp    $0x2,%bl
  je     ld3d3
  cmp    $0x3,%bl
  je     ld3d7
  cmp    $0x4,%bl
  je     ld3da
  jmp    ld3dd
ld3cd:in     (%dx),%al
  jmp    ld3df
ld3d0:in     (%dx),%ax
  jmp    ld3df
ld3d3:in     (%dx),%eax
  jmp    ld3df
ld3d7:out    %al,(%dx)
  jmp    ld3df
ld3da:out    %ax,(%dx)
  jmp    ld3df
ld3dd:out    %eax,(%dx)
ld3df:shr    $0x10,%ebx
  shrd   $0x10,%ecx,%edx
  shr    $0x10,%ecx
  ret    
ld3ed:  
 pushf  
  push   %ebx
  push   %ecx
  call   ld379
  pop    %ecx
  pop    %ebx
  popf   
  ret
   
lda17: .byte 0
print_msg:
  popl %cs:msg-2
  push %cs:msg-2
  save_seg ax
   pushf
  pusha
  xpushregs %ds,%es,%fs,%gs
  save_seg  sp
  mov %ss,%cs:save_sp+2
  set_segs %cs
  lea mini_stack,%sp
   mov msg,%si
  call dos_puts
  lss %cs:save_sp,%sp
  xpopregs %gs,%fs,%es,%ds
 popa
  popf
  ret

die_at 13b6
die_at 3dac
die_at 31fd
die_at 0212
die_at 0213
die_at 021c
die_at 0236
die_at 1357
die_at 388d
die_at 7a6
die_at d7d0
die_at f7b1    
die_at 000a
die_at 0085
die_at 0104
die_at 010a
die_at 0116
die_at 012c
die_at 012e
die_at 015b
die_at 0203
die_at 020a
die_at 02ae
die_at 0302
die_at 0306
die_at 0308
die_at 030b
die_at 030c
die_at 030e
die_at 030f
die_at 0310
die_at 0311
die_at 0317
die_at 0318
die_at 031c
die_at 0324
die_at 0328
die_at 032a
die_at 032f
die_at 0338
die_at 033a
die_at 033c
die_at 033d
die_at 0345
die_at 0349
die_at 034a
die_at 034c
die_at 0366
die_at 0369
die_at 0380
die_at 0381
die_at 0383
die_at 0384
die_at 0385
die_at 0387
die_at 0389
die_at 038f
die_at 0391
die_at 0392
die_at 0393
die_at 0397
die_at 039c
die_at 039d
die_at 039f
die_at 03ae
die_at 03c4
die_at 08c9
die_at 0ac2
die_at 0d23
die_at 0d8f
die_at 0dbf
die_at 0dda
die_at 0e86
die_at 0ec7
die_at 0eff
die_at 0f44
die_at 1021
die_at 1057
die_at 1080
die_at 10be
die_at 123c
die_at 1296
die_at 134b
die_at 1351
die_at 1364
die_at 1368
die_at 136a
die_at 1382
die_at 1386
die_at 1398
die_at 1458
die_at 145b
die_at 14e9
die_at 14f8
die_at 15e3
die_at 15e6
die_at 15e9
die_at 15ec
die_at 1700
die_at 1726
die_at 1763
die_at 1819
die_at 184c
die_at 187d
die_at 189e
die_at 18f3
die_at 1980
die_at 1983
die_at 1986
die_at 1989
die_at 198c
die_at 1aaf
die_at 1acc
die_at 1b12
die_at 1b21
die_at 1b48
die_at 1b96
die_at 1c1e
die_at 1c5c
die_at 1d28
die_at 1d36
die_at 1d41
die_at 1d65
die_at 1d7a
die_at 1d82
die_at 1d8c
die_at 1e01
die_at 1e23
die_at 1e5b
die_at 1e97
die_at 1ea9
die_at 1f51
die_at 2422
die_at 296b
die_at 296e
die_at 2bfe
die_at 309a
die_at 3f01
die_at 6e0e
die_at 6e55
die_at 6e58
die_at 6f25
die_at 7229
die_at 723c
die_at 7247
die_at 7258
die_at 7271
die_at 75e6
die_at 75eb
die_at 75f0
die_at 75f5
die_at 7812
die_at 8114
die_at 8120
die_at 8122
die_at 8132
die_at 8146
die_at 8150
die_at 8152
die_at 815c
die_at 8160
die_at 8162
die_at 816a
die_at 816c
die_at 816e
die_at 8176
die_at 8222
die_at 8252
die_at 8309
die_at 831a
die_at 8329
die_at 8333
die_at 8342
die_at 8348
die_at 834b
die_at 8351
die_at 8354
die_at 8358
die_at 8359
die_at 835a
die_at 8367
die_at 836b
die_at 8370
die_at 837c
die_at 8388
die_at 8399
die_at 839e
die_at 83a0
die_at 83a2
die_at 83a4
die_at 83a8
die_at 83aa
die_at 83ac
die_at 83b2
die_at 83b5
die_at 83b6
die_at 83ba
die_at 83bc
die_at 83bd
die_at 83be
die_at 83bf
die_at 83c1
die_at 83c2
die_at 83c3
die_at 8f40
die_at 8f9b
die_at 934e
die_at 9372
die_at 937e
die_at 938a
die_at 938b
die_at 938c
die_at 9390
die_at 9395
die_at 93b0
die_at 93b4
die_at 9788
die_at 99fb
die_at 9c0c
die_at 9c5c
die_at 9d65
die_at 9da2
die_at b3a8
die_at b408
die_at bc5a
die_at ff57

.bss
orig_cs: .word 0
save_ax: .word 0
save_sp: .long 0
msg: .long 0
  .space 4096
 mini_stack: .word 0
