# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

   init_args
   arg_item v,verbose,"be verbose"
  arg_value m,"set mcr"
   call strtoul_
   mov %al,mcr
   movb $1,set_mcr
    ret
.data
set_mcr: .byte 0
mcr: .byte 0
  ret
  arg_value p,"port num 0..n"
    call strtoul_
   dec %ax
  mov %ax,port
   ret
.data
port: .word 0
  init_args_term
    port2uart port
    mov %ax,uart
  if_z set_mcr,0f,b
     serial_mcr uart,mcr
  if_z argc,exit_prog,w
0: if_nz argc,0f
   exit_msg $1,"I demand you give me something to do! either a divisor or mcr"
0:   mov argv,%si
  call strtoul_
  mov %al,divisor
  serial_config uart,divisor
  if_z verbose,0f,b
   print "set port 0x"
     fdhex $1,4,port
   print " to divisor "
  fdhex $1,8,divisor,$'\n'
0:
exit_prog:  terminate 00
.data
divisor: .byte 12
.bss
uart: .word 0
