# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

  init_args
    arg_value d,"baud rate divisor"
  call strtoul_
  mov %al,divisor
  ret
divisor: .byte 0xc
   arg_value p,"com port"
  call strtoul_
  mov %ax,port
  ret
port: .word 0
 init_args_term

  lea buf,%di
  mov argc,%cx
  if_rz %cx,1f
  lea argv,%bx
0:    mov  (%bx),%si
   call add_to_buf
  add $sizeof_int,%bx
  loop 0b
1:  movb $0,(%di)

   port2uart port
  mov %ax,uart
  serial_config uart,divisor
  push $buf
  push uart
  call serial_puts
  terminate 00
add_to_buf:
0:   lodsb
  if_rz %al,50f
   stosb
  jmp 0b
50:  movb $' ',(%di)
  inc %di
  ret
.bss
uart: .word 0
buf: .space 256
