# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

.struct 0
partition_record _
.previous

    init_args
   arg_value p,"partition"
   call  strtoul_
    mov %al,g_partition
   ret
.data
g_partition: .byte 1
   init_args_term
  if %ax,a,$1,0f
   exit_msg $1,"need at least os defaults to drive 0x80"
0:  mov argv,%si 
  call strtoul_
   mov %al,g_os
1:  if argc,b,$2,0f
    mov argv+sizeof_int,%si
   call strtoul_
   mov %al,g_drive
0: push g_os
 push g_partition
  push g_drive
  call set_os
   terminate 00

parm_start
parm_sym drive,.word 0
parm_sym partition,.word 0
parm_sym os,.word 0
parm_end
lstruct
lsym buf, .space _d_sector_sz
lstruct_end
set_os: enter $lstruct_sz,$0
  zeroreg %dh
  mov drive(%bp),%dl
  mov $1,%cx
  mov %cl,%al
   lea buf(%bp),%bx
  pusha
  read_sector
  exit_if_cf $1,"read sector failed"
  lea buf+0x1be(%bp),%si
  zeroreg %bh
  mov partition(%bp),%bl
     dec %bl
      shl  $4,%bl
  add %bx,%si
   mov os(%bp),%al
  mov %al,_os(%si)
  popa
  write_sector
  exit_if_cf $1,"write failed"
   leave
    ret $ret_sz
.data
g_os: .word 0
g_drive: .byte 0x80
cyl: .word 0
sector: .byte 1
