# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

.macro smbios_gpnv_read_data h,buf,lock,seg=%ds
 push \seg
 push \seg
  push \lock
 push \seg
  push \buf
  push \h
  push $0x56
  call pnp_bios_
 add $0xe,%sp
.endm

  call com_init_mem
 call pnp_bios_init
  exit_if_cf ofd,"cant find pnp"
  smbios_gpnv_get_info $smbios_handle,$buf_sz,$sz_alloc
  if_rnz %ax,0f
  exhibit ofd,16,smbios_handle
  exhibit ofd,16,buf_sz
  exhibit ofd,16,sz_alloc
  jmp 1f
0:  fdprint ofd,"gpnv info not supported\n"
1:
  smbios_gpnv_read_data $0,$buf,$lock
   printreg ax $'\n'
  exit_msg $1,"exit ok"

ofd: .word _d_stdout_fileno 
smbios_handle:  .word 0
lock: .word 0xffff
.bss
buf_sz: .word 0
sz_alloc: .word 0
buf: .space 0x8000
