# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"

  init_args
  arg_value t,"tick freq"
  call strtoul_
  mov %eax,freq
  ret
.data
freq: .long 1
  arg_value l,"timer latch"
   call strtoul_
  mov  %ax,latch
   ret
.data
latch: .word 0xffff
   arg_value d,"baud divisor"
   call strtoul_
  mov %eax,divisor
   ret
.data
divisor: .long 12
   init_args_term
   set_counter0 $0x34,latch
   get_vector $8
  mov %eax,old_int8
   port2uart $0
  mov %ax,uart
  serial_config uart,divisor
  set_vector $8,%cs,$int8_hdlr

0:  bios_check_keystroke
  jnz exit_prog
  jmp 0b

exit_prog: set_vector $8,old_int8
  serial_config uart,$12
   set_counter0 $0x36,$0xffff
    terminate 00
int8_hdlr:
  pushal
  push %ds
  movseg %cs,%ds
  incl jiffies
   mov jiffies,%eax
    zeroreg %edx
   mov freq,%ecx
  div %ecx
     if_rnz %edx,0f
  playnote_ms $440,$100
0:  mov $0x60,%al
   out %al,$0x20
  pop %ds
  popal
  iret
.data
jiffies: .long 0
.bss
old_int8: .long 0
uart: .word 0
