# dosutils, routines and examples to use in dos and 16 bit executables
# Copyright (C) 2012 neil foster <neil.foster@vampyre-adsl.demon.co.uk>
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
.include "maclib.h"
.include "uhci-mac.h"

  puts "this is now uhci00"
  movw $qtd_array,uhci_qtd_p
call   l7a2c
  call   l42d9
  exit_msg $1,"ok thats all folks"
l7a2c:
    pci16_find_class $_d_pci_uhci_usb_class
   exit_if_cf $1,"no uhci dev found"
   mov %ax,pci_slot
  movb $0,uhci_root_type
     pci16_read_first_ioaddr pci_slot
  and $~3,%ax
   mov %ax,uhci_ioaddr
  uhci_config_usbcmd uhci_ioaddr
  uhci_init_usbintr uhci_ioaddr
 uhci16_init_framelist uhci_ioaddr,$framelist_space
  mov %ax,uhci_hd_p
  uhci_enable_ports uhci_ioaddr
  ret    
l42d9:
  fdhex $1,16,uhci_ioaddr
_outw $0,uhci_ioaddr,$_d_usbintr
  io_setbitsw uhci_ioaddr,$_d_usbcmd,$_d_usbcmd_rs
 
  mov $2,%cx
   zeroreg %bx
0:  call   l3d54
   inc %bx
  loop 0b
  ret    
l3d54:
  pusha

  movb $0,uhci_dev_addr
 uhci_reset_port uhci_ioaddr,%bx
   inc %bl
  usb_set_dev_addr $uhci_usbdev,%bx
   fdputc $' ',$1
    fdhex $1,8,uhci_dev_addr,$' '
  usb_get_dev_descriptor $uhci_usbdev,$0x0,$uhcidev_std_dev_descriptor,$0
  fdprint handle,"vendor/product/cfgs="
  fdhex handle,16,uhcidev_vendor,$'/'
 fdhex handle,16,uhcidev_product,$'/'
 fdhex handle,8,uhcidev_num_cfgs,$'\n'

  f_memset $l5557,$0,$0x400
  do_urb $uhci_usbdev,$set_cfg,l5557,$0,$0
  mov uhcidev_imft,%bl
  call dev_str
  mov uhcidev_iproduct,%bl
  call dev_str
  mov uhcidev_iserial,%bl
  call dev_str
999:
  popa
ret    
dev_str:
  pusha
  if_rz %bl,999f
   f_memset $l5557,$0,$0x400
  usb_get_string_descriptor $uhci_usbdev,%bx,$l5557,$0xdf,$0
   movzbw l5557,%cx
  jcxz 999f
  lea l5557+2,%si
  call printsw
   dos_newline
999:  popa
  ret
printsw:
  pusha
   shr %cx
  jz 999f
  cld
0:  lodsw
  dos_writedl_con %al
    loop 0b
999:
  popa
  ret
.data
usbdev_t uhci_,urd=uhci_usbrootdev
set_cfg:  .byte 0x00,0x09,0x01,0x00,0x00,0x00,0x00,0x00
handle: .word 1
.bss
std_dev_descriptor_t uhcidev_
.space 0x400
port_num: .byte 0
usbrootdev_t uhci_
.align 0x10
qtd_array: .space 0x40
pci_slot: .word 0
l5557: .space 0x400
framelist_space: .space 8192
